/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2013 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
*/

package nos.edit;

import java.awt.BorderLayout;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

@SuppressWarnings("serial")
public abstract class FenCreeNom extends JDialog implements PropertyChangeListener {

	private JOptionPane optionPane;

	private String btnOK = "OK";

	private String btnAnnuler = "Annuler";

	protected JTextField nom = new JTextField(20);
	
	public FenCreeNom(String titre) {

		super();
		setModalityType(DEFAULT_MODALITY_TYPE);
		Object[] options = { btnOK, btnAnnuler };

		JPanel panel1 = new JPanel();
		JLabel lab = new JLabel(titre);
		panel1.add(lab);
		panel1.add(nom);
		getContentPane().add(panel1, BorderLayout.NORTH);

		// Create the JOptionPane.
		optionPane = new JOptionPane(null,
				JOptionPane.PLAIN_MESSAGE,
				JOptionPane.OK_CANCEL_OPTION, null, options, options[0]);
		optionPane.addPropertyChangeListener("value", this);
		getContentPane().add(optionPane, BorderLayout.SOUTH);
	}

	/** This method reacts to state changes in the option pane. */
	public void propertyChange(PropertyChangeEvent e) {
		String prop = e.getPropertyName();
		if ((e.getSource() == optionPane)
			&& (JOptionPane.VALUE_PROPERTY.equals(prop) || JOptionPane.INPUT_VALUE_PROPERTY
						.equals(prop)))  {
			Object value = optionPane.getValue();
			
			if (value == JOptionPane.UNINITIALIZED_VALUE) {
				// ignore reset
				return;
			}
			
			if (btnOK.equals(value)) {
				if (nom.getText().length() == 0) {
					JOptionPane.showMessageDialog(this, "Vous devez saisir un nom...");
					// Reset the JOptionPane's value.
					// If you don't do this, then if the user
					// presses the same button next time, no
					// property change event will be fired :
					 optionPane.setValue( JOptionPane.UNINITIALIZED_VALUE);
				} else {
					cree();
				}
			} else { // user closed dialog or clicked cancel
				dispose();
			}
		}
	}
	
	protected void saisieNonValide() {
		 optionPane.setValue( JOptionPane.UNINITIALIZED_VALUE);
	}

	abstract void annule(); 
	
	abstract void cree(); 
}
