/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2013-2021 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
*/

package nos.edit;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JInternalFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JTextPane;
import javax.swing.KeyStroke;
import javax.swing.event.InternalFrameEvent;
import javax.swing.event.InternalFrameListener;

import nos.obj.Edi;
import nos.obj.EdiNoS;
import nos.utils.ToolNos;

@SuppressWarnings("serial")
public class FenInfos extends JInternalFrame implements InternalFrameListener {

	private JMenuBar menuBar;
	
	private JButton boutonFermer = new JButton("Fermer");

	private JTextPane zoneTexte = new JTextPane();

	public FenInfos() {
		super("A propos d'EdiNoS", true, // resizable
				true, // closable
				true, // maximizable
				true);// iconifiable
		addInternalFrameListener(this);
		
		getContentPane().setLayout(new BorderLayout());

		JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.LINE_AXIS));
		panel.add(boutonFermer);
		panel.add(Box.createHorizontalGlue());
		panel.setBorder(BorderFactory.createLineBorder(Color.white));

		getContentPane().add(panel, BorderLayout.NORTH);

		JPanel panelImage = new JPanel();

		java.net.URL imgURL = getClass().getResource("/images/Clever le peintre Small.gif");

		ImageIcon image = null;
		if (imgURL != null) {
			image = new ImageIcon(imgURL);
		} else {
			Edi.nos().montreInfo("Image non trouvée");
		}
		
		JLabel label3 = new JLabel(image);
		panelImage.add(label3);
		
		getContentPane().add(panelImage, BorderLayout.CENTER);
		
		zoneTexte.setEditable(false); 
		zoneTexte.setContentType("text/html");
		zoneTexte.setMargin(new Insets(3,3,3,3));
		zoneTexte.setText("EdiNoS version " + ((EdiNoS) Edi.nos()).getVersion() + "<br>" +
				"Copyright (C) 2013-2021 - Luc Poittevin - Tous droits réservés."+ "<br>" +
				"Contact : edinos@free.fr - https://edinos.org"+ "<br>" +
				"<br>" +
				"Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le "+ 
				"modifier suivant les termes de la “GNU General Public License” telle que "+ 
				"publiée par la Free Software Foundation : soit la version 3 de cette "+
				"licence, soit (à votre gré) toute version ultérieure."+ 
				"<br>" + "<br>" +
				"Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS "+ 
				"AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ ni   "+ 
				"d'ADÉQUATION À UN OBJECTIF PARTICULIER."+ "<br>" + 
				"Consultez la Licence Générale Publique GNU pour plus de détails."+ "<br>" +
				"<br>" +
				"Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec "+ "<br>" +
				"ce programme ; si ce n’est pas le cas, consultez : "+
				"<a href=\"http://www.gnu.org/licenses/\">http://www.gnu.org/licenses/</a>."+"<br>"+ "<br>");
		
		getContentPane().add(zoneTexte, BorderLayout.SOUTH);
		
		registerEventListeners();
		
		// Ajout 17/03/2021 : // LPO
		ActionListener actionListenerEsc = new ActionListener() {
			public void actionPerformed(ActionEvent actionEvent) {
				fermeFen();
			}
		};
		KeyStroke stroke = KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0);
		getRootPane().registerKeyboardAction(actionListenerEsc, stroke, JComponent.WHEN_IN_FOCUSED_WINDOW);
		
		installeMenus();
		
		pack();
	}
	
	private void registerEventListeners() {
		boutonFermer.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				fermeFen();
			}
		});
	}
	
	protected void fermeFen() {
		if (ToolNos.nomSysteme().equals("Mac")) {
			ToolNos.fermeFen((JInternalFrame) this);
		} else {
			dispose();
		} 
		((FenEdiNoS) Edi.nos().fen()).checkDerniereFen(); 
	}

	private void installeMenus() {
		FenEdiNoS ed = (FenEdiNoS) Edi.nos().fen();
		menuBar = ed.menuBarEdinos();
		menuBar.add(menuInfos());
		Edi.nos().fen().setJMenuBar(menuBar);
		Edi.nos().fen().setVisible(true);
	}
	
	private JMenu menuInfos() {

		JMenuItem menuItem;
		JMenu menu = new JMenu("A propos");

		menu.addSeparator();
		menuItem = new JMenuItem("Fermer la fenêtre");
		menuItem.setAccelerator(KeyStroke.getKeyStroke(
				java.awt.event.KeyEvent.VK_W, ToolNos.renvoieModifiers()));
		menuItem.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				// Modif 18/03/2020 :
				// dispose();
				fermeFen();
			}
		});
		menu.add(menuItem);
		return (menu);
	}
	
	public void internalFrameActivated(InternalFrameEvent e) {
		Edi.nos().fen().setJMenuBar(menuBar);
		Edi.nos().fen().setVisible(true);
	}

	public void internalFrameClosed(InternalFrameEvent e) {
	}

	public void internalFrameClosing(InternalFrameEvent e) {
		fermeFen();
	}

	public void internalFrameDeactivated(InternalFrameEvent e) {
		((FenEdiNoS) Edi.nos().fen()).setMenuBar();
	}

	public void internalFrameDeiconified(InternalFrameEvent e) {
	}

	public void internalFrameIconified(InternalFrameEvent e) {
	}

	public void internalFrameOpened(InternalFrameEvent e) {
	}
}
