/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2013-2018 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
*/

package nos.edit;

import javax.swing.JOptionPane;

import nos.obj.Edi;

@SuppressWarnings("serial")
public class FenRenommeAction extends FenCreeNom {

	private FenActions fen = null;

	public FenRenommeAction(FenActions f, String nomActuel) {
		super("Entrez le nouveau nom de l'action");
		setTitle("Renommer l'action <"+nomActuel+">");
		nom.setText(nomActuel);
		fen = f;
	}

	@Override
	void cree() {
		if ((Edi.nos().getBaseCourante()
				.contientProc(nom.getText()))||(Edi.nos().getBaseCourante()
						.contientQuestion(nom.getText()))) {
			// Ne pas utiliser Edi.nos().message() car FenRenommeAction
			// est déjà une JOptionPane de Edi.nos()
			JOptionPane.showMessageDialog(this, "L'action <"
					+ nom.getText() + "> existe déjà...");
			saisieNonValide();
			return;
		};
		fen.renommeAction(nom.getText());
		dispose();
	}

	@Override
	void annule() {
	}
}
