/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2013 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
*/

package nos.edit;

import java.beans.PropertyVetoException;

import javax.swing.DefaultDesktopManager;
import javax.swing.JDesktopPane;
import javax.swing.JInternalFrame;


// 18/03/2020 : solution abandonnée...

// Le DesktopManager par défaut sous Mac ne gère pas bien
// la sélection automatique de la première frame 
// derrière la frame qui est fermée : une solution pourrait être de 
// créer un MyDesktopManager

// Mais :

// Pb avec le look & Feel "Mac OS X" depuis Java 8 / Mac OS :
// http://stackoverflow.com/questions/28774432/exception-in-the-iconization-of-jinternalframe-with-defaultdesktopmanager
// bug ouvert chez Oracle :
// http://bugs.java.com/bugdatabase/view_bug.do?bug_id=JDK-8170794
// 
// Plantage de la commande suivante dans FenEdinos
// desktop.setDesktopManager(dm);

// Finalement on opte pour des appels à ToolNos.fermeFen() depuis les méthodes internalFrameClosing()


@SuppressWarnings("serial")
public class MyDesktopManager extends DefaultDesktopManager {

	MyDesktopManager() {
		super();
	}

	public void closeFrame(JInternalFrame f) {
		JDesktopPane d = f.getDesktopPane();
		JInternalFrame[] iframes = d.getAllFrames();
		f.setVisible(false);
		f.getDesktopPane().remove(f);
		f.setVisible(false);
		for (int i = 0; i < iframes.length; i++) {
			JInternalFrame iframe =iframes[i];
			if (!iframe.equals(f)) {
				try {
					iframe.setSelected(true);
				} catch (PropertyVetoException e) {
				}
				return;
			}
		}
	}
}
