/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2013-2020 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
*/

package nos.edit;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.BoxLayout;
import javax.swing.DefaultComboBoxModel;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JInternalFrame;
import javax.swing.JList;
import javax.swing.JMenuBar;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.KeyStroke;
import javax.swing.event.InternalFrameEvent;
import javax.swing.event.InternalFrameListener;

import nos.obj.Edi;
import nos.utils.ToolNos;

@SuppressWarnings("serial")
public class PaletteNoS extends JInternalFrame implements ActionListener,
		InternalFrameListener {

	private JCheckBox checkBox = new JCheckBox(" Liste locale   ");

	private JButton boutonDemander = new JButton("demander");
	private JButton boutonEvaluer = new JButton("evaluer");
	private JButton boutonDeclencher = new JButton("declencher");
	private JButton boutonAfficher = new JButton("afficher");

	private JButton boutonSi = new JButton("si");
	private JButton boutonEt = new JButton("ET");
	private JButton boutonOu = new JButton("OU");
	private JButton boutonNon = new JButton("NON");
	private JButton boutonParOuv = new JButton("(");
	private JButton boutonParFerm = new JButton(")");
	private JButton boutonAlorsAller = new JButton("alorsAller");
	private JButton boutonPriorite = new JButton("priorite");
	private JButton boutonAller = new JButton("aller");
	
	private Color couleurRegles = Color.LIGHT_GRAY;

	private JList<String> liste = new JList<String>();

	private DefaultListModel<String> listModel = new DefaultListModel<String>();

	private JComboBox<String> combo = new JComboBox<String>();

	private FenNos fenNoS;
	
	private JMenuBar menuBar;

	PaletteNoS(FenNos f) {
		super("Palette d'édition du NoS <" + f.getNoS().getNom() + ">", true, // resizable
				true, // closable
				true, // maximizable
				true);// iconifiable
		addInternalFrameListener(this);
		fenNoS = f;

		Dimension dimFen = new Dimension(350, 310);
		getContentPane().setPreferredSize(dimFen);
		
		checkBox.setOpaque(true);
		boutonDemander.setOpaque(true);
		boutonEvaluer.setOpaque(true);
		boutonDeclencher.setOpaque(true);
		boutonAfficher.setOpaque(true);
		
		JPanel panel = new JPanel();
		panel.setLayout(new GridLayout(7, 1));
		panel.setPreferredSize(new Dimension(120, 160)); //150
		panel.add(boutonDemander);
		panel.add(boutonEvaluer);
		panel.add(boutonDeclencher);
		panel.add(boutonAfficher);
		panel.add(boutonAller);
		panel.add(boutonPriorite);
		panel.add(boutonAlorsAller);
		panel.setBackground(couleurRegles);
		panel.setOpaque(true);
		getContentPane().add(panel, BorderLayout.WEST);

		JPanel panel2 = new JPanel();
		panel2.setLayout(new BoxLayout(panel2, BoxLayout.Y_AXIS));
		JPanel panel2b = new JPanel(); // inutile
		panel2b.setLayout(new BoxLayout(panel2b, BoxLayout.X_AXIS));

		String comboBoxItems[] = { "Liste des nos", "Liste des questions",
				"Liste des procédures", "Liste des messages", "Liste des faits", "Liste des graphes" };
		DefaultComboBoxModel<String> cbm = new DefaultComboBoxModel<String>(comboBoxItems);
		combo.setModel(cbm);
		combo.setEditable(false);
		combo.addActionListener(this);
		
		checkBox.setActionCommand("cocheCheckBox");
		checkBox.addActionListener(this);
		checkBox.setSelected(true);

		panel2b.add(checkBox, BorderLayout.WEST);
		panel2b.add(combo, BorderLayout.CENTER);


		getContentPane().add(panel2b, BorderLayout.NORTH);

		JScrollPane listPane1 = new JScrollPane(liste);
		listPane1.setPreferredSize(new Dimension(250, 210)); 
		panel2.add(listPane1, BorderLayout.CENTER);
		getContentPane().add(panel2, BorderLayout.CENTER);

		JPanel panel3 = new JPanel();
		panel3.setLayout(new GridLayout(2, 3));
		panel3.add(boutonSi);
		panel3.add(boutonEt);

		panel3.add(boutonOu); 
		panel3.add(boutonNon);
		panel3.add(boutonParOuv);
		panel3.add(boutonParFerm);
		panel3.setBackground(couleurRegles);
		panel3.setOpaque(true);
		getContentPane().add(panel3, BorderLayout.SOUTH);

		installeMenus();

		registerEventListeners();

		afficheListeNoS();

		pack();
	}

	private void installeMenus() {

		FenEdiNoS ed = (FenEdiNoS) Edi.nos().fen();
		menuBar = ed.menuBarEdinos();
		menuBar.add(ed.menuBase());
		menuBar.add(fenNoS.menuNoS());
		Edi.nos().fen().setJMenuBar(menuBar);
		Edi.nos().fen().setVisible(true);
	}

	public void actionPerformed(ActionEvent e) {
		String s = e.getActionCommand().toString();

		if ((s.equals("comboBoxChanged"))||(s.equals("cocheCheckBox"))) {
			switch (combo.getSelectedIndex()) {
			case 0:
				// "Liste des nos"
				afficheListeNoS();
				break;
			case 1:
				// "Liste des questions"
				afficheListeQuestions();
				break;
			case 2:
				// "Liste des procédures"
				afficheListeProcs();
				break;
			case 3:
				// "Liste des messages"
				afficheListeMessages();
				break;
			case 4:
				// "Liste des faits"
				afficheListeFaits();
				break;
			case 5:
				// "Liste des graphes"
				afficheListeGraphes();
				break;
			}
			return;
		}
	}

	private void registerEventListeners() {
		boutonDemander.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				insereZoneActionDebutLigne("demander:");
				combo.setSelectedIndex(1); // liste des questions
			}
		});
		boutonEvaluer.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				insereZoneActionDebutLigne("evaluer:");
				combo.setSelectedIndex(2); // liste des procs
			}
		});
		boutonDeclencher.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				insereZoneActionDebutLigne("declencher:");
				combo.setSelectedIndex(5); // liste des graphes
			}
		});
		boutonAfficher.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				insereZoneActionDebutLigne("afficher:");
				combo.setSelectedIndex(3); // liste des messages
			}
		});
		boutonAller.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				insereZoneRegleDebutLigne("aller:");
				combo.setSelectedIndex(0); // liste des nos
			}
		});
		boutonPriorite.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				insereZoneRegle(" priorite: ");
			}
		});
		boutonAlorsAller.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				insereZoneRegle(" alorsAller:");
				combo.setSelectedIndex(0); // liste des nos
			}
		});
		boutonSi.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				insereZoneRegleDebutLigne("si:");
				combo.setSelectedIndex(4); // liste des faits
			}
		});
		boutonEt.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				insereZoneRegle(" ET");
			}
		});
		boutonOu.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				insereZoneRegle(" OU");
			}
		});
		boutonNon.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				insereZoneRegle(" NON(");
			}
		});
		boutonParOuv.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				insereZoneRegle(" (");
			}
		});
		boutonParFerm.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				insereZoneRegle(")");
			}
		});
		liste.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				// if (e.getClickCount() == 2) {
				if ((e.getClickCount() == 2)
						&& (liste.getSelectedValue() != null)) {
					switch (combo.getSelectedIndex()) {
					case 0:
						// "Liste des nos"
						insereZoneRegle(' ' + liste.getSelectedValue()
								.toString());
						break;
					case 1:
						// "Liste des questions"
						insereZoneAction(' ' + liste.getSelectedValue()
								.toString() + ';');
						break;
					case 2:
						// "Liste des procédures"
						insereZoneAction(' ' + liste.getSelectedValue()
								.toString() + ';');
						break;
					case 3:
						// "Liste des messages"
						insereZoneAction(' ' + liste.getSelectedValue()
								.toString() + ';');
						break;
					case 4:
						// "Liste des faits"
						insereZoneRegle(' ' + liste.getSelectedValue()
								.toString());
						break;
					case 5:
						// "Liste des graphes"
						insereZoneAction(' ' + liste.getSelectedValue()
								.toString() + ';');
						break;
					}
					;
				}
			}
		});
		ActionListener actionListenerEsc = new ActionListener() {
			public void actionPerformed(ActionEvent actionEvent) {
				dispose();
			}
		};

		KeyStroke stroke = KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0);
		getRootPane().registerKeyboardAction(actionListenerEsc, stroke,
					JComponent.WHEN_IN_FOCUSED_WINDOW);  
	}

	private void afficheListeQuestions() {
		listModel.clear();

		for (String nomEcran : fenNoS.getNoS().getBase().getListeQuestions()) {
			listModel.addElement(nomEcran);
		}
		liste.setModel(listModel);
	}
	
	private void afficheListeMessages() {
		listModel.clear();

		for (String nomEcran : fenNoS.getNoS().getBase().getListeMessages()) {
			listModel.addElement(nomEcran);
		}
		liste.setModel(listModel);
	}


	private void afficheListeGraphes() {
		listModel.clear();


		for (String nomListe : fenNoS.getNoS().getBase().getListeGraphes()) {
			listModel.addElement(nomListe);
		}
		liste.setModel(listModel);
	}

	private void afficheListeFaits() {
		listModel.clear();

		
		String actions = fenNoS.getNoS().getActions();
		fenNoS.getNoS().setActions(fenNoS.getZoneTexteActions().getText());
		
		if (checkBox.isSelected()) {
			// "Liste locale" : liste des faits attendus du nos courant :
			for (String nomFait : fenNoS.getNoS().tousLesFaitsAttendus()) {
				listModel.addElement(nomFait);
			}
		} else {
			// liste de tous les faits attendus de la base :
			for (String nomFait : fenNoS.getNoS().getBase().getListeFaitsAppeles()) {
				listModel.addElement(nomFait);
			}
		}
		
		fenNoS.getNoS().setActions(actions);
		
		liste.setModel(listModel);
	}

	private void afficheListeNoS() {
		listModel.clear();

		if (checkBox.isSelected()) {
			for (String nomNoS : fenNoS.getNoS().getBase().getListeNoS()) {
				listModel.addElement(nomNoS);
			}
		} else {
			// liste de tous les nos de la base :
			for (String nomNoS : fenNoS.getNoS().getBase().getListeNoS()) {
				listModel.addElement(nomNoS);
			}
		}
		;
		liste.setModel(listModel);
	}

	private void afficheListeProcs() {
		listModel.clear();

		for (String nomProc : fenNoS.getNoS().getBase().getListeProcs()) {
			listModel.addElement(nomProc);
		}
		
		liste.setModel(listModel);
	}

	private void insereZoneAction(String s) {
		fenNoS.getZoneTexteActions().insert(s,fenNoS.getZoneTexteActions().getCaretPosition());
		fenNoS.getZoneTexteActions().grabFocus();
	}

	private void insereZoneRegle(String s) {
		fenNoS.getZoneTexteRegles().insert(s,fenNoS.getZoneTexteRegles().getCaretPosition());
		fenNoS.getZoneTexteRegles().grabFocus();
	}

	private void insereZoneActionDebutLigne(String s) {
		JTextArea zone = fenNoS.getZoneTexteActions();
		if (zone.getText().length() > 0) {
			zone.append('\n' + s);
		} else {
			zone.append(s);
		};
		zone.grabFocus(); // pour afficher:
        //Make sure the new text is visible, even if there
        //was a selection in the text area.
		zone.setCaretPosition(zone.getDocument().getLength());
	}

	private void insereZoneRegleDebutLigne(String s) {
		JTextArea zone = fenNoS.getZoneTexteRegles();
		if (zone.getText().length() > 0) {
			if (!zone.getText().endsWith(";")) {
				zone.append(";\n" + s);
			} else {
				zone.append('\n' + s);
			}
		} else {
			zone.append(s);
		}
        //Make sure the new text is visible, even if there
        //was a selection in the text area.
		zone.setCaretPosition(zone.getDocument().getLength());
		fenNoS.getZoneTexteRegles().grabFocus();
	}

	public void internalFrameActivated(InternalFrameEvent e) {
		Edi.nos().fen().setJMenuBar(menuBar);
		Edi.nos().fen().setVisible(true);
	}

	public void internalFrameDeactivated(InternalFrameEvent e) {
		((FenEdiNoS) Edi.nos().fen()).setMenuBar();
	}

	public void internalFrameClosed(InternalFrameEvent e) {
		fenNoS.fermePalette();
	}

	public void internalFrameClosing(InternalFrameEvent e) {
		ToolNos.fermeFen((JInternalFrame) this);
	}

	public void internalFrameDeiconified(InternalFrameEvent e) {
	}

	public void internalFrameIconified(InternalFrameEvent e) {
	}

	public void internalFrameOpened(InternalFrameEvent e) {
	}
}
