/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2013 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
*/

package nos.edit;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.font.TextLayout;
import java.awt.geom.Rectangle2D;
import java.util.HashSet;
import java.util.Set;

import javax.swing.BorderFactory;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;

import nos.edit.FenGraphe.PanelGraphe;
import nos.obj.Edi;
import nos.obj.NoS;

public class PanelNoS extends JPanel implements MouseListener,
		MouseMotionListener {

	private static final long serialVersionUID = 1L;

	private NoS nos = null;
	
	private int largeur = 140;
	
	private int hauteur = 40;

	private PanelGraphe graphe;

	// Holds the coordinates of the user's last mousePressed event.
	private int x, y, x_in, y_in;
	

	private JPopupMenu popup;


	public PanelNoS(NoS n, PanelGraphe g) {

		JMenuItem menuItem;

		nos = n;
		graphe = g;

		x = n.getPosX();
		y = n.getPosY();

		x_in = 0;
		y_in = 0;


		popup = new JPopupMenu();

		if (nos.getRaccourci()) {
			menuItem = new JMenuItem("Rallonger");
			menuItem.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					rallonge();
				}
			});
		} else {
			menuItem = new JMenuItem("Raccourcir");
			menuItem.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					raccourcit();
				}
			});
		}
		popup.add(menuItem);

		menuItem = new JMenuItem("Créer un lien");
		menuItem.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				graphe.actionCreeLien();
			}
		});
		popup.add(menuItem);
		menuItem = new JMenuItem("Créer un fils");
   		menuItem.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				graphe.actionCreeFils();
			}
		});
		popup.add(menuItem);
		menuItem = new JMenuItem("Renommer");
   		menuItem.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				graphe.actionRenommeNoS();
			}
		});
		popup.add(menuItem);
		
		// Add listener to components that can bring up popup menus.
		MouseListener popupListener = new PopupListener();
		addMouseListener(popupListener);

		addMouseMotionListener(this);
		addMouseListener(this);

		// setForeground(Color.blue);
		setBorder(BorderFactory.createLineBorder(Color.black));
		setBounds(x, y, largeur, hauteur);
		setOpaque(true);
	}

//	public PanelNoS(String nom, int x_depart, int y_depart) {
//		// INUTILISE
//
//		x = x_depart;
//		y = y_depart;
//
//		x_in = 0;
//		y_in = 0;
//
////		last_y = y;
//
//		popup = new JPopupMenu();
//		JMenuItem menuItem = new JMenuItem("A popup menu item");
//		// menuItem.addActionListener(this);
//		popup.add(menuItem);
//		menuItem = new JMenuItem("Another popup menu item");
//
//		// menuItem.addActionListener(this);
//		popup.add(menuItem);
//
//		// Add listener to components that can bring up popup menus.
//		MouseListener popupListener = new PopupListener();
//		addMouseListener(popupListener);
//
//		addMouseMotionListener(this);
//		addMouseListener(this);
//
//		/*
//		 * // Creates the fill texture paint pattern. bi = new BufferedImage(5,
//		 * 5, BufferedImage.TYPE_INT_RGB); big = bi.createGraphics();
//		 * big.setColor(Color.green); big.fillRect(0, 0, 1, 1); //
//		 * big.setColor(Color.green); // big.fillOval(0, 0, 3, 3); Rectangle r =
//		 * new Rectangle(0, 0, 0, 1); fillPolka = new TexturePaint(bi, r);
//		 * big.dispose(); // setBounds(x, y, 140, 80);
//		 */
//
//		setBackground(Color.blue);
//		// setForeground(Color.blue);
//		setBorder(BorderFactory.createLineBorder(Color.black));
//		setBounds(x, y, 140, 40);
//		setOpaque(true);
//	}

	public void paintComponent(Graphics g) {
		super.paintComponent(g);
		Graphics2D g2 = (Graphics2D) g;

		

		if (nos.getRaccourci() == true) {
			setBackground(Color.blue);
		} else {
			setBackground(Color.green);
		}
		
		if (nos.getRaccourci() == true) {
			g2.setColor(Color.white);
		} else {
			g2.setColor(Color.black);
		}

		String nom = "nodule";
		if (nos != null) {
			nom = nos.getNom();
		}

		TextLayout thisTl = new TextLayout(nom,
				new Font("Verdana", 0, 10), g2.getFontRenderContext());
		
		 Rectangle2D bounds = thisTl.getBounds();
		 int largeurTexte = (int)bounds.getWidth();
		 if (largeurTexte > largeur) {
			 int cible = largeur*nom.length()/largeurTexte;
			 thisTl = new TextLayout(nom.substring(0, cible - 3) + "...",
						new Font("Verdana", 0, 10), g2.getFontRenderContext());
			 bounds = thisTl.getBounds();
			 largeurTexte = (int)bounds.getWidth();
		 };
		 thisTl.draw(g2, largeur/2-largeurTexte/2, 20);

	






	}

	public void raccourcit() {

		// "*** on construit <liste> des nos à effacer ***"

		Set<NoS> ens = nos.tousLesNoSSuivantsAafficher(new HashSet<NoS>());

		// Cas des nos ayant d'autres ancetres...
		// "*** on retire de <ens> tous les éléments (et leurs ***"
		// "*** descendants) qui ont d'autres ancêtres ...     ***"
			
		Set<NoS> autres = graphe.getListeNosAffiches();
		autres.removeAll(ens);
		ens.remove(nos);

		for (NoS n : ens) {
			if (!n.parentsAffichesDans(autres).isEmpty()) {
				// "*** il existe un ancetre de <nos> qui ne fait pas   ***"
				// "*** partie de la liste à effacer : il ne faut effacer: ***"
				// "*** ni <nos>, ni ses descendants : on les stocke    ***"
				// "*** dans <autres>, et on mettra à jour <liste> quand   ***"
				// "*** on sera sorti de la boucle.                        ***"
				autres.add(n);
				for (NoS e : n.tousLesNoSSuivantsAafficher(new HashSet<NoS>())) {
					autres.add(e);
				}
			}
		}

		ens.removeAll(autres);
		ens.add(nos);
		graphe.effaceNoS(ens);

		nos.setRaccourci(true);
		PanelNoS n = new PanelNoS(nos, graphe);
		graphe.ajouteNoS(n);

		graphe.repaint();
		dessineCourant(); // ne fonctionne pas
	}

	public void rallonge() {

		graphe.remove(this);
		nos.setRaccourci(false);
		Set<NoS> ens = nos.tousLesNoSSuivantsAafficher(new HashSet<NoS>());

		for (NoS nos : ens) {
			PanelNoS n = new PanelNoS(nos, graphe);
			graphe.ajouteNoS(n);
		}

		setBackground(Color.green);
		graphe.setPreferredSize(graphe.getTaille());
		graphe.repaint();
		dessineCourant(); // ne fonctionne pas
	}

	public void dessineCourant() {
		this.setBorder(BorderFactory.createLineBorder(Color.black, 2));
	}

	public void dessineNormal() {
		this.setBorder(BorderFactory.createLineBorder(Color.black));
	}

	public void mouseClicked(MouseEvent e) {
		if (e.getClickCount() == 2) {
			FenNos f = new FenNos(nos);
			nos.getBase().ajouteFen(f);
			((FenEdiNoS) Edi.nos().fen()).ouvreInternalFrame(f);
		}
	}

	public void mousePressed(MouseEvent e) {
		graphe.noduleClique(this);
		dessineCourant();
		x_in = e.getX();
		y_in = e.getY();
	}

	public void mouseReleased(MouseEvent arg0) {
		updateLocation(arg0);
	}

	public void mouseEntered(MouseEvent arg0) {

	}

	public void mouseExited(MouseEvent arg0) {

	}

	public void mouseDragged(MouseEvent arg0) {
		updateLocation(arg0);
	}

	public void mouseMoved(MouseEvent arg0) {

	}

	public void updateLocation(MouseEvent e) {

		x = x - x_in + e.getX();
		y = y - y_in + e.getY();
		setBounds(x, y, largeur,hauteur);

		nos.setPos(String.valueOf(x) + "@" + String.valueOf(y));

		repaint();
		this.getParent().repaint();
	}

	public int getX() {
		return x;
	}

	public int getY() {
		return y;
	}
	
	public NoS getNoS() {
		return nos;
	}

	class PopupListener extends MouseAdapter {
		public void mousePressed(MouseEvent e) {
			maybeShowPopup(e);
		}

		public void mouseReleased(MouseEvent e) {
			maybeShowPopup(e);
		}

		private void maybeShowPopup(MouseEvent e) {
			if (e.isPopupTrigger()) {
				popup.show(e.getComponent(), e.getX(), e.getY());
			}
		}
	}
}
