/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2018-2019 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
 */

package nos.edit.html;

import java.util.ArrayList;
import java.util.List;

import javax.swing.ImageIcon;
import javax.swing.table.AbstractTableModel;

import nos.obj.FaitAttendu;

@SuppressWarnings("serial")
public class TableFaitsEdit extends AbstractTableModel {


	protected String[] colonnes = new String[] { "", "Nom", "Type", "" };

	protected List<Object[]> listeFaits;


	public TableFaitsEdit(List<FaitAttendu> l) {
		super();
		listeFaits = new ArrayList<Object[]>();
		construitListeFaits(l);
	}

	public void supprime(int row) {
		listeFaits.remove(row);
		this.fireTableDataChanged();
	}
	

	void ajouteData(FaitAttendu f) {
		java.net.URL imgURLDel = getClass().getResource("/icones/cross.png");
		java.net.URL imgURLDet = getClass()
				.getResource("/icones/page_edit.png");
		Object[] tab = { new ImageIcon(imgURLDel), f.getNom(), f.getType(),
				new ImageIcon(imgURLDet), f.getDescription() };
		listeFaits.add(tab);
	}
	
	public int getColumnCount() {
		return colonnes.length;
	}

	public int getRowCount() {
		return listeFaits.size();
	}

	public Object getValueAt(int i, int j) {
		Object[] ligne = listeFaits.get(i);
		return ligne[j];
		
	}

	public boolean isCellEditable(int row, int col) {
		return true;
	}

	public void setValueAt(Object value, int row, int col) {
		Object[] ligne = listeFaits.get(row);
		ligne[col] = value;
		fireTableCellUpdated(row, col);
	}

	public String getColumnName(int c) {
		return (colonnes[c]);
	}

	public String[] getListeType() {
		// TODO à remplacer en utilisant FaitAttendu.TypeFaitAttendu...
		return new String[] { "Proposition", "Chaine", "Entier", "Réel" };
	}

	public List<FaitAttendu> construitListeFaitsAttendus() {
		List<FaitAttendu> listeFaitsAttendus = new ArrayList<FaitAttendu>();
		for (Object[] ligne : listeFaits) {
			String nom = (String) ligne[1];
			FaitAttendu f = new FaitAttendu(nom);
			String type = (String) ligne[2];
			f.setType(type);
			String desc = (String) ligne[4];
			f.setDescription(desc);
			listeFaitsAttendus.add(f);
		}
		return listeFaitsAttendus;
	}
	
	private void construitListeFaits(List<FaitAttendu> l) {
		for (FaitAttendu f : l) {
			ajouteData(f);
		}
	}
}
