/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2014-2020 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
 */

package nos.revinos;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;

import javax.swing.JComponent;
import javax.swing.JInternalFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.KeyStroke;
import javax.swing.event.InternalFrameEvent;
import javax.swing.event.InternalFrameListener;

import nos.obj.Edi;
import nos.edit.FenEdiNoS;
import nos.run.Moteur;
import nos.utils.ToolNos;

@SuppressWarnings("serial")
public class FenRevinos1 extends JInternalFrame implements InternalFrameListener {

	private Moteur moteur;

	private JMenuBar menuBar;

	public FenRevinos1(Moteur m) {
		super("ReviNoS", true, // resizable
				true, // closable
				true, // maximizable
				true);// iconifiable
		// Pour retirer la bordure basse sous MacOS :
//		this.putClientProperty("JInternalFrame.frameType", "normal");
		addInternalFrameListener(this);
		moteur = m;
		initComponents();
		initComponents2();
		installeMenus();
	}

	private void initComponents2() {
		jRadioButton1.setActionCommand("infosOK");
		jRadioButton1.setName("infosOK"); // pour FEST
		jRadioButton2.setActionCommand("infoManquante");
		jRadioButton2.setName("infoManquante"); // pour FEST
		jRadioButton3.setActionCommand("infoErronee");
		jRadioButton3.setName("infoErronee"); // pour FEST
		jRadioButton4.setActionCommand("infoInutile");
		jRadioButton4.setName("infoInutile"); // pour FEST

		buttonGroup1.add(jRadioButton1);
		buttonGroup1.add(jRadioButton2);
		buttonGroup1.add(jRadioButton3);
		buttonGroup1.add(jRadioButton4);

		jButton1.setName("OK"); // pour FEST

		ActionListener actionListenerEsc = new ActionListener() {
			public void actionPerformed(ActionEvent actionEvent) {
				// Ajout 17/03/2021 : // LPO
				((FenEdiNoS) Edi.nos().fen()).fermeFen("Sessions de révision");
				Revi.nos().fermeFenSessions();
				fermeFen();
			}
		};

		KeyStroke stroke = KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0);
		getRootPane().registerKeyboardAction(actionListenerEsc, stroke, JComponent.WHEN_IN_FOCUSED_WINDOW);
	}

	private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {
		// Bouton OK

		if (buttonGroup1.getSelection() != null) {
			((FenEdiNoS) Edi.nos().fen()).fermeFen("Voir la situation");
			((FenEdiNoS) Edi.nos().fen()).fermeFen("Situation inédite");
			fermeFen();
			String choix = buttonGroup1.getSelection().getActionCommand();
			if (moteur.getCible().getNoS().getNom().isEmpty()) {
				moteur.getBaseFaits().ajouteFait("situationInédite");
			} else {
				moteur.getBaseFaits()
						.ajouteFait("actionErronee.nom " + moteur.getCible().getNoS().getNomPremiereAction());
				moteur.getBaseFaits()
						.ajouteFait("actionErronee.type " + moteur.getCible().getNoS().getTypePremiereAction());
			}
			;
			Revi.nos().lance(moteur.getCible(), moteur);
			moteur.retourne(choix);
		}
	}

	private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {
		// Bouton Annuler
		// Ajout 17/03/2021 : // LPO
		((FenEdiNoS) Edi.nos().fen()).fermeFen("Sessions de révision");
		Revi.nos().fermeFenSessions();

		fermeFen();
	}

	private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {
		// Bouton Fermer
		// Ajout 17/03/2021 : // LPO
		((FenEdiNoS) Edi.nos().fen()).fermeFen("Sessions de révision");
		Revi.nos().fermeFenSessions();

		fermeFen();
	}

	protected void fermeFen() {
		if (ToolNos.nomSysteme().equals("Mac")) {
			ToolNos.fermeFen((JInternalFrame) this);
		} else {
			dispose();
		}
		((FenEdiNoS) Edi.nos().fen()).checkDerniereFen();
	}

	private void installeMenus() {
		menuBar = ((FenEdiNoS) Edi.nos().fen()).menuBarEdinos();
		menuBar.add(menuRevinos());
		Edi.nos().fen().setJMenuBar(menuBar);
		Edi.nos().fen().setVisible(true);
	}

	private JMenu menuRevinos() {

		JMenuItem menuItem;
		JMenu menu = new JMenu("Dialogue ReviNoS");

		menuItem = new JMenuItem("Fermer la fenêtre");
		menuItem.setAccelerator(KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_W, ToolNos.renvoieModifiers()));
		menuItem.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				fermeFen();
			}
		});
		menu.add(menuItem);
		return (menu);
	}

	public void internalFrameActivated(InternalFrameEvent e) {
		Edi.nos().fen().setJMenuBar(menuBar);
		Edi.nos().fen().setVisible(true);
	}

	public void internalFrameClosed(InternalFrameEvent e) {
	}

	public void internalFrameClosing(InternalFrameEvent e) {
		ToolNos.fermeFen((JInternalFrame) this);
	}

	public void internalFrameDeactivated(InternalFrameEvent e) {
		((FenEdiNoS) Edi.nos().fen()).setMenuBar();
	}

	public void internalFrameDeiconified(InternalFrameEvent e) {
	}

	public void internalFrameIconified(InternalFrameEvent e) {
	}

	public void internalFrameOpened(InternalFrameEvent e) {
	}

	/**
	 * This method is called from within the constructor to initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is always
	 * regenerated by the Form Editor.
	 */

	// <editor-fold defaultstate="collapsed" desc="Generated Code">
	private void initComponents() {

		buttonGroup1 = new javax.swing.ButtonGroup();
		jRadioButton1 = new javax.swing.JRadioButton();
		jRadioButton2 = new javax.swing.JRadioButton();
		jRadioButton3 = new javax.swing.JRadioButton();
		jRadioButton4 = new javax.swing.JRadioButton();
		jLabel6 = new javax.swing.JLabel();
		jButton1 = new javax.swing.JButton();
		jButton2 = new javax.swing.JButton();
		jPanel1 = new javax.swing.JPanel();
		jButton3 = new javax.swing.JButton();

		setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
//        setMaximumSize(new java.awt.Dimension(380, 460));
//        setMinimumSize(new java.awt.Dimension(380, 460));
//        setPreferredSize(new java.awt.Dimension(380, 460));

		setMaximumSize(new java.awt.Dimension(380, 440));
		setMinimumSize(new java.awt.Dimension(380, 440));
		setPreferredSize(new java.awt.Dimension(380, 440));

		setResizable(false);

		jRadioButton1.setText("Les informations sont correctes et complètes");

		jRadioButton2.setText("Il manque une information");

		jRadioButton3.setText("Une information est erronée");

		jRadioButton4.setText("Une information est inutile");

		jLabel6.setText("mais l'action effectuée n'est pas adéquate");

		jButton1.setText("OK");
		jButton1.setToolTipText("");
		jButton1.setPreferredSize(new java.awt.Dimension(90, 30));
		jButton1.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jButton1ActionPerformed(evt);
			}
		});

		jButton2.setText("Annuler");
		jButton2.setToolTipText("");
		jButton2.setMaximumSize(new java.awt.Dimension(90, 30));
		jButton2.setMinimumSize(new java.awt.Dimension(90, 30));
		jButton2.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jButton2ActionPerformed(evt);
			}
		});

		jPanel1.setBorder(javax.swing.BorderFactory.createEtchedBorder());

		jButton3.setText("Fermer");
		jButton3.setFocusable(false);
		jButton3.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		jButton3.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
		jButton3.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jButton3ActionPerformed(evt);
			}
		});

		org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
		jPanel1.setLayout(jPanel1Layout);
		jPanel1Layout.setHorizontalGroup(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
				.add(jPanel1Layout.createSequentialGroup().add(jButton3).addContainerGap(279, Short.MAX_VALUE)));
		jPanel1Layout.setVerticalGroup(
				jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING).add(jButton3));

		org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
		getContentPane().setLayout(layout);
		layout.setHorizontalGroup(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
				.add(jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE,
						org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
				.add(org.jdesktop.layout.GroupLayout.TRAILING,
						layout.createSequentialGroup().addContainerGap(66, Short.MAX_VALUE).add(jLabel6).add(41, 41,
								41))
				.add(layout.createSequentialGroup().add(29, 29, 29)
						.add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING).add(jRadioButton4)
								.add(jRadioButton3).add(jRadioButton2)
								.add(jRadioButton1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 325, Short.MAX_VALUE))
						.addContainerGap())
				.add(org.jdesktop.layout.GroupLayout.TRAILING,
						layout.createSequentialGroup().addContainerGap(133, Short.MAX_VALUE)
								.add(jButton2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE,
										org.jdesktop.layout.GroupLayout.DEFAULT_SIZE,
										org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
								.add(18, 18, 18).add(jButton1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 96,
										org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
								.add(30, 30, 30)));
		layout.setVerticalGroup(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING).add(layout
				.createSequentialGroup()
				.add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE,
						org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
				.add(37, 37, 37).add(jRadioButton1).addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
				.add(jLabel6)
				.addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 18,
						org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
				.add(jRadioButton2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 60, Short.MAX_VALUE).add(32, 32, 32)
				.add(jRadioButton3).add(48, 48, 48).add(jRadioButton4).add(43, 43, 43)
				.add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
						.add(jButton1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE,
								org.jdesktop.layout.GroupLayout.DEFAULT_SIZE,
								org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
						.add(jButton2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE,
								org.jdesktop.layout.GroupLayout.DEFAULT_SIZE,
								org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
				.add(26, 26, 26)));

		pack();
	}// </editor-fold>

	// Variables declaration - do not modify
	private javax.swing.ButtonGroup buttonGroup1;
	private javax.swing.JButton jButton1;
	private javax.swing.JButton jButton2;
	private javax.swing.JButton jButton3;
	private javax.swing.JLabel jLabel6;
	private javax.swing.JPanel jPanel1;
	private javax.swing.JRadioButton jRadioButton1;
	private javax.swing.JRadioButton jRadioButton2;
	private javax.swing.JRadioButton jRadioButton3;
	private javax.swing.JRadioButton jRadioButton4;
	// End of variables declaration

}
