/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2013-2020 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
 */

package nos.revinos;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.DefaultListModel;
import javax.swing.JInternalFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.KeyStroke;
import javax.swing.event.InternalFrameEvent;
import javax.swing.event.InternalFrameListener;

import nos.obj.Edi;
import nos.edit.FenEdiNoS;
import nos.run.MoteurBilan;
import nos.utils.ToolNos;

@SuppressWarnings("serial")
public class FenSoumissionExemple3 extends JInternalFrame implements
		InternalFrameListener {

	private JMenuBar menuBar;

	private String nomAction;

	private MoteurBilan cycle;

	private String titre;

	public FenSoumissionExemple3(MoteurBilan c, String n, String t) {
		// Situation à valider, après l'application de l'opérateur de révision 
		super(t, true, // resizable
				true, // closable
				true, // maximizable
				true);// iconifiable
		// Pour retirer la bordure basse sous MacOS :
//		this.putClientProperty("JInternalFrame.frameType", "normal");
		addInternalFrameListener(this);
		cycle = c;
		nomAction = n;
		titre = t;
		initComponents();
		initComponents2();
		installeMenus();
	}

	private void initComponents2() {
		Edi.nos().montreInfo("REVINOS - Soumission Exemple - " + titre);

		jLabel4.setText(nomAction);
		
		/* Onglet "Etat de la MT" : */
		DefaultListModel listModel = new DefaultListModel();
		for (String nomAction : cycle.getBaseFaits().getFaits()) {
			listModel.addElement(nomAction);
		}
		
		jList1.setModel(listModel);
		jScrollPane1.setViewportView(jList1);

		/* Onglet "Historique" : */
		DefaultListModel listModel2 = new DefaultListModel();
		for (String nomFait : cycle.getBaseFaits().getListeHistorique()) {
			listModel2.addElement(nomFait);
		}
		jList2.setModel(listModel2);
		jScrollPane2.setViewportView(jList2);
		
		jRadioButton1.setActionCommand("pasDeSens");
		jRadioButton2.setActionCommand("statueraPlusTard");
		jRadioButton3.setActionCommand("oui");
		jRadioButton4.setActionCommand("non");
		jRadioButton1.setName("pasDeSens"); // pour FEST
		jRadioButton2.setName("statueraPlusTard"); // pour FEST
		jRadioButton3.setName("oui"); // pour FEST
		jRadioButton4.setName("non"); // pour FEST

		buttonGroup1.add(jRadioButton1);
		buttonGroup1.add(jRadioButton2);
		buttonGroup1.add(jRadioButton3);
		buttonGroup1.add(jRadioButton4);

		jButton1.setName("OK"); // pour testNG
		jButton2.setName("annuler"); // pour testNG;
		jLabel1.setName("jLabel1"); // pour testNG
		jLabel3.setName("jLabel3"); // pour testNG
		jLabel4.setName("jLabel4"); // pour testNG
		jLabel6.setName("jLabel6"); // pour testNG

		jList1.setName("bF"); // pour testNG
		jList2.setName("historique"); // pour testNG
	}

	private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {
		// Bouton Annuler
		
		dispose();
		Revi.nos().retourne("ignoreExemple");
	}

	private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {
		// Bouton Fermer
		dispose();
	}

	private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {
		// Bouton OK
		
		String choix = "";
		if (buttonGroup1.getSelection() != null) {
			choix = buttonGroup1.getSelection().getActionCommand();
		} else {
			JOptionPane.showMessageDialog(this,
					"Vous n'avez pas choisi de réponse...");
			return;
		}
		
		dispose();
		if (choix.equals("statueraPlusTard")) {
			Revi.nos().ouvreFenSessions(cycle, Sessions.Statut.AStatuer);
			Revi.nos().retourne(choix);
		} else if (choix.equals("pasDeSens")) {
			Revi.nos().retourne(choix);
		} else if (choix.equals("non")) {
			Revi.nos().ouvreFenSessions(cycle, Sessions.Statut.NonDémarrée);
			Revi.nos().retourne("rejetteExemple");
		} else if (choix.equals("oui")) {
			Revi.nos().retourne("accepteExemple");
		}
	}

	private void installeMenus() {
		menuBar = ((FenEdiNoS) Edi.nos().fen()).menuBarEdinos();
		menuBar.add(menuRevinos());
		Edi.nos().fen().setJMenuBar(menuBar);
		Edi.nos().fen().setVisible(true);
	}

	private JMenu menuRevinos() {

		JMenuItem menuItem;
		JMenu menu = new JMenu("Dialogue ReviNoS");

		menuItem = new JMenuItem("Fermer la fenêtre");
		menuItem.setAccelerator(KeyStroke.getKeyStroke(
				java.awt.event.KeyEvent.VK_W, ToolNos.renvoieModifiers()));
		menuItem.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				dispose();
			}
		});
		menu.add(menuItem);
		return (menu);
	}

	public void internalFrameActivated(InternalFrameEvent e) {
		Edi.nos().fen().setJMenuBar(menuBar);
		Edi.nos().fen().setVisible(true);
	}

	public void internalFrameClosed(InternalFrameEvent e) {
	}

	public void internalFrameClosing(InternalFrameEvent e) {
		ToolNos.fermeFen((JInternalFrame) this);
	}

	public void internalFrameDeactivated(InternalFrameEvent e) {
		((FenEdiNoS) Edi.nos().fen()).setMenuBar();
	}

	public void internalFrameDeiconified(InternalFrameEvent e) {
	}

	public void internalFrameIconified(InternalFrameEvent e) {
	}

	public void internalFrameOpened(InternalFrameEvent e) {
	}

    // <editor-fold defaultstate="collapsed" desc="Generated Code">
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        jLabel6 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        jButton3 = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList();
        jScrollPane2 = new javax.swing.JScrollPane();
        jList2 = new javax.swing.JList();
        jRadioButton1 = new javax.swing.JRadioButton();
        jLabel1 = new javax.swing.JLabel();
        jRadioButton2 = new javax.swing.JRadioButton();
        jRadioButton3 = new javax.swing.JRadioButton();
        jRadioButton4 = new javax.swing.JRadioButton();

//        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jLabel6.setText("faut-il effectuer l'action suivante :  ");

        jButton1.setText("OK");
        jButton1.setToolTipText("");
        jButton1.setMaximumSize(new java.awt.Dimension(95, 30));
        jButton1.setMinimumSize(new java.awt.Dimension(75, 30));
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jButton2.setText("Annuler");
        jButton2.setToolTipText("");
        jButton2.setMaximumSize(new java.awt.Dimension(75, 30));
        jButton2.setMinimumSize(new java.awt.Dimension(75, 30));
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jPanel1.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jButton3.setText("Fermer");
        jButton3.setFocusable(false);
        jButton3.setIgnoreRepaint(true);
        jButton3.setMaximumSize(new java.awt.Dimension(60, 30));
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .add(jButton3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(460, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .add(jButton3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );

        jLabel3.setText("Dans la situation suivante :");

        jLabel4.setBackground(java.awt.Color.lightGray);
        jLabel4.setText("jLabel4");
        jLabel4.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jLabel4.setFocusable(false);
        jLabel4.setOpaque(true);

        jList1.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jScrollPane1.setViewportView(jList1);

        jTabbedPane1.addTab("Etat de la MT", jScrollPane1);

        jList2.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jScrollPane2.setViewportView(jList2);

        jTabbedPane1.addTab("Historique", jScrollPane2);

        jRadioButton1.setText("cette situation n'a pas sens,");

        jLabel1.setText("il n'est pas utile de s'y intéresser...");

        jRadioButton2.setText("statuer plus tard");

        jRadioButton3.setText("oui");

        jRadioButton4.setText("non");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(jTabbedPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 220, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(66, 66, 66)
                        .add(jButton2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 105, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(26, 26, 26)
                        .add(jButton1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 104, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(layout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 267, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jLabel6)
                            .add(layout.createSequentialGroup()
                                .add(21, 21, 21)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(jRadioButton3)
                                    .add(jRadioButton4)
                                    .add(jRadioButton2)
                                    .add(jRadioButton1)
                                    .add(layout.createSequentialGroup()
                                        .add(29, 29, 29)
                                        .add(jLabel1)))))))
                .addContainerGap())
            .add(layout.createSequentialGroup()
                .add(24, 24, 24)
                .add(jLabel3)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 32, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                        .add(8, 8, 8)
                        .add(jLabel3)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jTabbedPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 266, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(layout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabel6)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabel4)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                        .add(jRadioButton3)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                        .add(jRadioButton4)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                        .add(jRadioButton2)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                        .add(jRadioButton1)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabel1)
                        .add(17, 17, 17)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jButton2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jButton1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap())
        );

        pack();
    }// </editor-fold> 

    // Variables declaration - do not modify
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JList jList1;
    private javax.swing.JList jList2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JRadioButton jRadioButton1;
    private javax.swing.JRadioButton jRadioButton2;
    private javax.swing.JRadioButton jRadioButton3;
    private javax.swing.JRadioButton jRadioButton4;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTabbedPane jTabbedPane1;
    // End of variables declaration
}
