/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2015-2019 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
*/

package nos.run;

import java.awt.Dimension;
import java.awt.Point;
import java.util.ArrayList;
import java.util.List;

import nos.edit.FenActions;
import nos.edit.FenEdiNoS;
import nos.obj.Edi;
import nos.obj.NoS;
import nos.revinos.*;
import nos.run.edit.FenDialogueRevinos;
import nos.utils.ToolNos;

public class InterfaceRevi {
	
	public static void calculePere(Moteur m) {
		/* DESCRIPTION: 
		nodCourant.nom CHAINE;
		*/
		Edi.nos().montreInfo("REVINOS - calculePere");
		
		List<String> p = m.getCible().getBaseFaits().getParcours();
		String nomNos = p.get(p.size()-2);
		if (Edi.nos().getBaseCourante().getNoS(nomNos).getTypeAction().equals("declencher")) {
			nomNos = p.get(p.size()-3);
		};
		Edi.nos().montreInfo("calculePere -> "+nomNos);
		m.retourne("nodCourant.nom "+nomNos);
	}
	
	public static void choixAction1(Moteur m) {
		 FenChoixAction1 f = new FenChoixAction1(m);

		 m.getNoS().getBase().ajouteFen(f);
		 ((FenEdiNoS) Edi.nos().fen()).ouvreInternalFrame(f);
		 f.setVisible(true);
	}
	
	public static void choixAction2(Moteur m) {
		 FenChoixAction2 f = new FenChoixAction2(m);

		 m.getNoS().getBase().ajouteFen(f);
		 ((FenEdiNoS) Edi.nos().fen()).ouvreInternalFrame(f);
		 f.setVisible(true);
	}
	
	public static void choixAction3(Moteur m) {
		 FenChoixAction3 f = new FenChoixAction3(m);

		 m.getNoS().getBase().ajouteFen(f);
		 ((FenEdiNoS) Edi.nos().fen()).ouvreInternalFrame(f);
		 f.setVisible(true);
	}
	
	public static void choixSituation1(Moteur m) {
		 FenChoixSituation1 f = new FenChoixSituation1(m);

		 m.getNoS().getBase().ajouteFen(f);
		 ((FenEdiNoS) Edi.nos().fen()).ouvreInternalFrame(f);
		 f.setVisible(true);
	}
	
	public static void choixSituation2(Moteur m) {
		 FenChoixSituation2 f = new FenChoixSituation2(m);

		 m.getNoS().getBase().ajouteFen(f);
		 ((FenEdiNoS) Edi.nos().fen()).ouvreInternalFrame(f);
		 f.setVisible(true);
	}
	
	public static void CP(Moteur m) {
		revisionInterrompue(m);
	}
	
	public static void a1(Moteur m) {
		Edi.nos().montreInfo("REVINOS - a1");
		
	    Revi.nos().operateurA1(m);
	}
	
	public static void a2(Moteur m) {
		Edi.nos().montreInfo("REVINOS - a2");
		
	    Revi.nos().operateurA2(m);
	}
	
	public static void creeRegle(Moteur m) {
		Edi.nos().montreInfo("REVINOS - creeRegle");
		
	    Revi.nos().creeRegle(m);
	}
	
	public static void nouveauNoS(Moteur m) {
		/* DESCRIPTION:
		nodAutiliser.nom CHAINE;
		nodRepris;
		*/
		FenNouveauNoS f = new FenNouveauNoS(m);

		 m.getNoS().getBase().ajouteFen(f);
		 ((FenEdiNoS) Edi.nos().fen()).ouvreInternalFrame(f);
		 f.setVisible(true);
	}
	
	public static void NP(Moteur m) {
		/* DESCRIPTION:
		actionCréée;
		actionAutiliser.nom CHAINE;
		actionAutiliser.type CHAINE;
		*/
	   	Edi.nos().montreInfo("REVINOS - NP");
	   	
	   	// on ouvre la fenêtre Interface :
		FenActions fa = new FenActions(m.getCible().getNoS().getBase(), m);
		m.getNoS().getBase().ajouteFen(fa);
		 ((FenEdiNoS) Edi.nos().fen()).ouvreInternalFrame(fa);
		fa.setVisible(true);
		
		String titre = "[NP ("+m.getCible().getNoS().getNom()+")]";
		String texte = "Créez la nouvelle action et"+ "\n" +
			"indiquez les faits qu'elle renvoie."+ "\n"+ "\n" +
			"Ensuite seulement, cliquez sur"+"\n'Continuer'...";	
		FenDialogueRevinos f = new FenDialogueRevinos(texte, titre, m, "actionCréée");
		m.getNoS().getBase().ajouteFen(f);
		
		Point p = f.getLocation();
		Dimension size = fa.getSize();
		p.setLocation(p.x + size.width + 5, p.y);
		f.setLocation(p);
		 ((FenEdiNoS) Edi.nos().fen()).ouvreInternalFrameSansPositionner(f);
		f.setVisible(true);
	}
	
	public static void positionneCible(Moteur m) {
		/* Description : 
		 "<nodCible> est <nodAutiliser>"
		 nodCible.nom CHAINE;
		 */
    	Edi.nos().montreInfo("REVINOS - positionneCible");
		m.retourne("nodCible.nom "+m.getBaseFaits().valeur("nodAutiliser.nom"));
	}
	
	public static void positionneCourant(Moteur m) {
		/* Description : 
		nodCourant.nom CHAINE;
		 */
    	Edi.nos().montreInfo("REVINOS - positionneCourant");
		m.retourne("nodCourant.nom "+m.getCible().getNoS().getNom());
	}
	
	public static void remplaceAction(Moteur m) {
		revisionInterrompue(m);
	}
	
	public static void revisionInterrompue(Moteur m) {
		Edi.nos().message("Désolé, cette partie de REVINOS n'est pas encore complètement implémentée... Révision abandonnée...");
	}
	
	public static void situationCourante(Moteur m) {
		/*  DESCRIPTION: 
		(infosOK infoErronee infoManquante infoInutile);
		situationInédite;
		"Pour <infosOK> et <infoManquante> : "
		actionErronee.nom CHAINE;
		"Pour <infoErronee> : "
		actionAcorriger.nom CHAINE; */
		
		 FenRevinos1 f = new FenRevinos1(m);

		 f.setLocation(new Point(716, 2));//706, 2
		 m.getNoS().getBase().ajouteFen(f);
		 ((FenEdiNoS) Edi.nos().fen()).ouvreInternalFrameSansPositionner(f);
		 f.setVisible(true);
	}
	
	public static void uneReglePourNodCible(Moteur m) {
//		"*** on cherche si une règle activable mène à <nodCible> ***"
		/*  DESCRIPTION: 
		uneRèglePourNodCible;
		*/
		Edi.nos().montreInfo("REVINOS - uneReglePourNodCible");

		String nomNosCourant = m.getBaseFaits().valeur("nodCourant.nom");
		NoS nosCourant = Edi.nos().getBaseCourante().getNoS(nomNosCourant);
		String nomNosCible = m.getBaseFaits().valeur("nodCible.nom");
		System.out.println("nosCourant = "+nomNosCourant+" - nosCible = "+nomNosCible);		

	    List<List<String>> struct = ToolNos.asStructureSyntaxe(ToolNos.retireCommentaires(nosCourant.getRegles()));
	    for (List<String> elem : struct) {
	    	if (elem.get(0).equals("si:")) {
	    		String formule = elem.get(1);
	    		try {
					if (m.getCible().getBaseFaits().evalueFormule(formule)) {
						if (nomNosCible.equals(elem.get(3))) {
							m.retourne("uneRèglePourNodCible");
						}
					}
				} catch (NoSException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
	    	};
	    	if (elem.get(0).equals("aller:")) {
    			if (nomNosCible.equals(elem.get(1))) {
		    		m.retourne("uneRèglePourNodCible");
    			}
	    	}	
	    };
		m.retourne("");
	}
	
	public static void uneReglePourNodSuivant(Moteur moteur) {
//		"*** Vérifie si une règle activable mène à <nodSuivant> ***"
		/* Description : 
		nodSuivant.nom CHAINE;
		uneRèglePourNodSuivant;
		(premisseVide premisseNonVide);
		*/
		Edi.nos().montreInfo("REVINOS - uneReglePourNodSuivant");
		
//		"*** on calcule <nodSuivant>, puis on cherche   ***"
//		"*** si une règle activable mène à <nodSuivant> ***"
		
		String nomNosCourant = moteur.getBaseFaits().valeur("nodCourant.nom");
		NoS nosCourant = Edi.nos().getBaseCourante().getNoS(nomNosCourant);

		Moteur m = new Moteur(nosCourant, null, null);
		m.setBaseFaits(moteur.getCible().getBaseFaits());
		if (!nosCourant.getRegles().isEmpty()) {
			m.executeChoix(nosCourant.getRegles());
		};

		NoS nosSuivant = m.choixSuivant();
		if (nosSuivant != null) {
			moteur.getBaseFaits().ajoute("nodSuivant.nom "+nosSuivant.getNom());
		};

		//	    "*** y-a-t'il une règle qui mène à <nodSuivant> ? ***"
	    if (!m.getChoixPossibles().isEmpty()) {
	    	if (m.getChoixPossibles().containsKey(nosSuivant)) {
	    		moteur.getBaseFaits().ajoute("uneRèglePourNodSuivant");
	    	}
	    }
		
//	    "*** premisse vide ou non vide: ***"
	    List<List<String>> struct = ToolNos.asStructureSyntaxe(nosCourant.getRegles());
	    for (List<String> elem : struct) {
	    	if (elem.get(0).equals("aller:")) {
		    	if (elem.get(1).equals(nosSuivant.getNom())) {
		    		moteur.retourne("premisseVide");
		    	}
	    	}
	    };
		moteur.retourne("premisseNonVide");
	}
	
	public static void soumetExemples(Moteur moteur) {
		/* Description : 
		nodSuivantAoublier;
		*/
		Edi.nos().montreInfo("REVINOS - soumetExemples");

		String nomNosCourant = moteur.getBaseFaits().valeur("nodCourant.nom");
		NoS nosCourant = Edi.nos().getBaseCourante().getNoS(nomNosCourant);
		String nomNosSuivant = moteur.getBaseFaits().valeur("nodSuivant.nom");

		NoS nosSuivant = Edi.nos().getBaseCourante().getNoS(nomNosSuivant);
		
		NoS nosInit = Edi.nos().getBaseCourante().getGrapheQuiContientNos(nomNosCourant).getPremierNoS();
		if (nosInit == null) {
			Edi.nos().message("Anomalie 1 - soumetExemples");
		};
	    
//	    "*** <exp> est l'ensemble des parcours possibles ***"
//	    "*** qui aboutissent à <nosSuivant> : ***"
	    Bilan exp = new Bilan();
	    exp.lance(nosInit,nosSuivant);   
	    
//	    "*** On ne garde dans <expFiltre1> que les parcours ***"
//	    "*** qui sont passés aussi par <nomNodCourant> : ***"
	    
	    
	    List<MoteurBilan> expFiltre1 = new ArrayList<MoteurBilan>();
	    for (MoteurBilan c: exp.getMoteurBilans()) {
	    	int i = c.getBaseFaits().getParcours().lastIndexOf(nomNosCourant);
	    	if (c.getBaseFaits().getParcours().get(i+1).equals(nomNosSuivant)) {
	    		expFiltre1.add(c);
	    	}
	    };
		
//	    "*** On ne garde dans <expFiltre2> que les parcours qui ***"
//	    "*** ont utilisé la même règle que l'exemple courant :  ***"
	    List<String> r = Revi.nos().regleCourante(nosCourant, moteur.getCible().getBaseFaits());
	    List<MoteurBilan> expFiltre2 = new ArrayList<MoteurBilan>();
	    for (MoteurBilan c: expFiltre1) {
	    	// on compare les numéros de règles :
	    	if (Revi.nos().regleCourante(nosCourant, c.getBaseFaits()).get(2).equals(r.get(2))) {
	    		expFiltre2.add(c);
	    	}
	    };
		if (expFiltre2.isEmpty()) {
			Edi.nos().message("Anomalie 2 - soumetExemples");
		};
	    
	    Revi.nos().soumet(expFiltre2, moteur);
	}
}
