/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2013-2019 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
*/

package nos.run;

import java.util.List;

import nos.obj.Edi;
import nos.obj.Procedure;
import nos.edit.FenEdiNoS;
import nos.run.edit.FenDialogue;
import nos.run.edit.FenDialogueJFrame;
import nos.run.edit.FenSimuleProc;
import nos.run.edit.FenSimuleProcJFrame;
import nos.run.edit.FenSimuleProcPropTypee;
import nos.run.edit.FenSimuleProcPropTypeeJFrame;

public class SimuleProc {
	private Procedure proc;
	private Moteur moteur;
	private List<List<String>> sfa;
	private int compteur;

	public SimuleProc(Procedure p, Moteur m) {
		proc = p;
		moteur = m;
		
		sfa = p.formateFaitsAttendus();
		compteur = 0;
		if (sfa.size() == 0) {
			if (Edi.nos().fen() != null) {
				FenSimuleProc f = new FenSimuleProc(proc, this, moteur, null);
				proc.getBase().ajouteFen(f);
				((FenEdiNoS) Edi.nos().fen()).ouvreInternalFrameSansPositionner(f);
				f.setVisible(true);
			} else {
				FenSimuleProcJFrame f = new FenSimuleProcJFrame(proc, this, moteur, null);
				f.setVisible(true);
			}
		} else {
			retourne(null);
		}
	}

	public void retourne(String s) {
		if (compteur < sfa.size()) {
			String type = "";
			if (s != null) {
				moteur.ajouteFait(s);
			}
			List<String> l = sfa.get(compteur);
			String[] tab = l.get(0).split(" ");
			if (tab.length > 1) {
				type = tab[1];
			}
			if (type.equals("Chaine") || type.equals("Entier")
					|| type.equals("Réel")) {
				if (Edi.nos().fen() != null) {
					FenDialogue f = new FenSimuleProcPropTypee(proc, this, moteur, tab[0], type);
					compteur++;
					proc.getBase().ajouteFen(f);
					((FenEdiNoS) Edi.nos().fen()).ouvreInternalFrameSansPositionner(f);
					f.setVisible(true);
				} else {
					FenDialogueJFrame f = new FenSimuleProcPropTypeeJFrame(proc, this, moteur, tab[0], type);
					compteur++;
					f.setVisible(true);
				}
			} else {
				compteur++;
				if (Edi.nos().fen() != null) {
					FenDialogue f = new FenSimuleProc(proc, this, moteur, l);
					proc.getBase().ajouteFen(f);
					((FenEdiNoS) Edi.nos().fen()).ouvreInternalFrameSansPositionner(f);
					f.setVisible(true);
				} else {
					FenDialogueJFrame f = new FenSimuleProcJFrame(proc, this, moteur, l);
					f.setVisible(true);
				}
			}
		} else {
			moteur.retourne(s);
		}
	}
}
