/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2013-2019 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
 */

package nos.run.edit;

import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;

import nos.obj.Message;
import nos.run.Moteur;

public class FenAfficheDeleg extends FenDialogueDeleg implements IFenDialogue {

	private String texte;

	public FenAfficheDeleg(String t, Container fen) {
		super();
		texte = t;
		// On retire le " au début et à la fin :
		texte = texte.substring(1, t.length() - 1);
		
		frame = fen;
		init("Affichage");
		getZoneTexte().setEditable(false);
		getBoutonAide()
		.setToolTipText("Pourquoi m'affiche-t-on ce message ?");

		if (getMoteur() != null) {
//			Modif 27/11/2019 :
			getMoteur().traceAffichageMessage(t);
		}
	}

	public FenAfficheDeleg(Message m, Container fen) {
		super();
		texte = m.getTexte();
		frame = fen;
		init("Affichage");
		getZoneTexte().setEditable(false);
		getBoutonAide()
		.setToolTipText("Pourquoi m'affiche-t-on ce message ?");

		if (getMoteur() != null) {
//			Modif 27/11/2019 :
			getMoteur().traceAffichageMessage(m.getNom());
		}
	}

	public void construitBoutons() {
		JButton bouton = new JButton("Vu");
		bouton.setName("Vu"); // pour FEST
		getPanelBoutons().add(bouton);
		bouton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				cliqueVu();
			}
		});
	}

	public String libelle() {
		return "Message";
	}

	public void remplitZones() {
		getZoneTexte().append(texte);
	}

	@Override
	void escape() {
		fermeFenetre();
	}

	protected void cliqueVu() {
		dispose();
		if (getMoteur() != null) {
			getMoteur().retourne(null);
		}
	}
	
	@Override
	public void retour() {
		dispose();
		Moteur m = getMoteur();
		if (m != null) {
			getMoteur().back();
		}
	}
}
