/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2013-2019 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
*/

package nos.run.edit;

import nos.obj.Message;
import nos.run.Moteur;
import nos.utils.ToolNos;

@SuppressWarnings("serial")

public class FenAfficheJFrame extends FenDialogueJFrame {
	
	public FenAfficheJFrame(String t, Moteur m) {
		super(m);		
		delegue = new FenAfficheDeleg(t, this);
	}

	public FenAfficheJFrame(Message mes, Moteur m) {
		super(m);		
		setDelegue(mes);
	}
	
	private void setDelegue(Message mes) {
		// doit être identique à FenAffiche.setDelegue()...

		String s = mes.getTexte().trim();

		if (ToolNos.getJavaVersion() >= 1.8) {
			if (s.startsWith("<html")) {
				delegue = new FenAfficheDelegFX(mes, this);
			} else {
				delegue = new FenAfficheDeleg(mes.getTexte(), this);
			}
		} else {
			// Java 6 ou 7 : Java FX absent...
			if (s.startsWith("<html>")) {
				delegue = new FenDialogueMessHTMLDeleg(mes, this);
			} else {
				delegue = new FenAfficheDeleg(mes.getTexte(), this);
			}
		}
	}
}
