/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2013-2020 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
 */

package nos.run.edit;

import javax.swing.JButton;
import javax.swing.JInternalFrame;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.event.InternalFrameEvent;
import javax.swing.event.InternalFrameListener;

import nos.edit.FenEdiNoS;

import nos.obj.Edi;
import nos.run.Moteur;

@SuppressWarnings("serial")
abstract public class FenDialogue extends JInternalFrame implements
		InternalFrameListener {
	
	protected FenDialogueDeleg delegue;
	
	protected Moteur moteur;

	protected JButton boutonFermer = new JButton();

	protected JButton boutonAide = new JButton("?");
	
	protected JButton boutonRetour = new JButton("Retour");

	protected JTextArea zoneTexte = new JTextArea(6, 22);
	protected JPanel panelBoutons;

	FenDialogue() {
		super("", true, // resizable
				true, // closable
				true, // maximizable
				true);// iconifiable
		addInternalFrameListener(this);
	}

	FenDialogue(Moteur m) {
		super("", true, // resizable
				true, // closable
				true, // maximizable
				true);// iconifiable
		moteur = m;
		addInternalFrameListener(this);
	}

	protected void init(String titre) {
		delegue.init(titre);
	}
	
	protected void construitBoutons() {
		delegue.construitBoutons();
	}
	
	protected void installeMenus() {
		delegue.installeMenus();
	}
	
	protected void voirSituation() {
		delegue.voirSituation();
	}

	protected void registerEventListeners() {
		delegue.registerEventListeners() ;
	}
	
	public Moteur getMoteur() {
		return moteur;
	}
	
	public JButton getBoutonFermer() {
		return boutonFermer;
	}

	public JButton getBoutonAide() {
		return boutonAide;
	}
	
	public JButton getBoutonRetour() {
		return boutonRetour;
	}

	public JTextArea getZoneTexte() {
		return zoneTexte;
	}

	public JPanel getPanelBoutons() {
		return panelBoutons;
	}
	
	public void setPanelBoutons(JPanel jPanel) {
		panelBoutons = jPanel;
	}
	
	public void internalFrameActivated(InternalFrameEvent e) {
		Edi.nos().fen().setJMenuBar(delegue.getMenuBar());
		Edi.nos().fen().setVisible(true);
	}

	public void internalFrameClosed(InternalFrameEvent e) {
	}

	public void internalFrameClosing(InternalFrameEvent e) {
		delegue.fermeFenetre(); 
	}

	public void internalFrameDeactivated(InternalFrameEvent e) {
		((FenEdiNoS) Edi.nos().fen()).setMenuBar();
	}

	public void internalFrameDeiconified(InternalFrameEvent e) {
	}

	public void internalFrameIconified(InternalFrameEvent e) {
	}

	public void internalFrameOpened(InternalFrameEvent e) {
	}
}
