/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2017-2021 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
 */

package nos.run.edit;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Cursor;
import java.awt.Dimension;

import javafx.scene.Scene;
import javafx.scene.web.WebEngine;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JInternalFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JFrame;

import nos.obj.Edi;
import nos.utils.PrefsManager;
import javafx.application.Platform;
import javafx.embed.swing.JFXPanel;

public abstract class FenDialogueHTMLDelegFX extends FenDialogueDeleg {
	



	
	protected JFXPanel fxPanel = new JFXPanel();

	protected WebEngine webEngine;

	FenDialogueHTMLDelegFX() {
		super();
	}

	
	
	

	protected abstract Scene createScene();


	public void init(String titre) {
		if (frame instanceof JInternalFrame) {
			((JInternalFrame) frame).setTitle(titre);
			((JInternalFrame) frame).getContentPane().setLayout(
					new BorderLayout());
		} else {
			((JFrame) frame).setTitle(titre);
			((JFrame) frame).getContentPane().setLayout(new BorderLayout());
		}

		JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.LINE_AXIS));
		getBoutonRetour().setName("Retour"); // pour FEST
		panel.add(getBoutonRetour());
		getBoutonAide().setName("?"); // pour FEST
		getBoutonAide()
				.setToolTipText("Pourquoi me pose-t-on cette question ?");
		panel.add(getBoutonAide());
		if (getMoteur() != null) {
			getBoutonFermer().setText("Interrompre");
			getBoutonFermer().setToolTipText("Interrompre le lancement");
		} else {
			getBoutonFermer().setText("Fermer");
		}
		getBoutonFermer().setName("Interrompre"); // pour FEST
		panel.add(getBoutonFermer());

		panel.add(Box.createHorizontalGlue());
		panel.setBorder(BorderFactory.createLineBorder(Color.white));
		panel.setPreferredSize(new Dimension(350, 30));

		addToContentPane(panel, BorderLayout.NORTH);

		JPanel panel2 = new JPanel();
		panel2.setLayout(new BoxLayout(panel2, BoxLayout.Y_AXIS));
		JPanel panel2b = new JPanel();
		JLabel l2 = new JLabel(libelle(), JLabel.CENTER);
		l2.setForeground(Color.BLUE);
		l2.setName("libelle"); // pour FEST
		l2.setAlignmentY(JFrame.CENTER_ALIGNMENT);
		panel2b.add(l2, BorderLayout.CENTER);
		panel2.add(panel2b);
		
		Edi.nos().fen().setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
		
		Platform.runLater(new Runnable() {
			public void run() {
				// This method is invoked on the JavaFX thread
						Scene scene = createScene();
						fxPanel.setScene(scene);
			}
		});

		int l = ((PrefsManager) Edi.nos().getPreferences())
				.getFenDialogueLargeur();
		int h = ((PrefsManager) Edi.nos().getPreferences())
				.getFenDialogueHauteur();
		panel2.setPreferredSize(new Dimension(l, h));

		panel2.add(fxPanel, BorderLayout.CENTER);
		addToContentPane(panel2, BorderLayout.CENTER);

		setPanelBoutons(new JPanel());
		construitBoutons();
		addToContentPane(getPanelBoutons(), BorderLayout.SOUTH);

		registerEventListeners();

		installeMenus();

		// Resize the container to the preferred size
		if (frame instanceof JInternalFrame) {
			((JInternalFrame) frame).pack();
		} else {
			((JFrame) frame).pack();
		}
		Edi.nos().fen().setCursor(Cursor.getDefaultCursor());
	}

}
