/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2013-2015 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
 */

package nos.run.edit;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTextArea;

import nos.run.Moteur;

@SuppressWarnings("serial")
abstract public class FenDialogueJFrame extends JFrame {
	
	protected FenDialogueDeleg delegue;

	protected Moteur moteur;

	protected JButton boutonFermer = new JButton();

	protected JButton boutonAide = new JButton("?");
	
	protected JButton boutonRetour = new JButton("Retour");

	protected JTextArea zoneTexte = new JTextArea(6, 22);

	protected JPanel panelBoutons;

	FenDialogueJFrame() {
		super();
	}

	FenDialogueJFrame(Moteur m) {
		super();
		moteur = m;
	}

	protected void init(String titre) {
		delegue.init(titre);
	}
	
	public Moteur getMoteur() {
		return moteur;
	}
	
	public JButton getBoutonFermer() {
		return boutonFermer;
	}

	public JButton getBoutonAide() {
		return boutonAide;
	}
	
	public JButton getBoutonRetour() {
		return boutonRetour;
	}

	public JTextArea getZoneTexte() {
		return zoneTexte;
	}

	public JPanel getPanelBoutons() {
		return panelBoutons;
	}
	
	public void setPanelBoutons(JPanel jPanel) {
		panelBoutons = jPanel;
	}
}
