/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2013-2019 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
*/

package nos.run.edit;

import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;

import javax.swing.JButton;

import nos.obj.Question;
import nos.utils.ToolNos;

public class FenDialogueQuestDeleg extends FenDialogueDeleg implements IFenDialogue {
	
	private Question question;

	public FenDialogueQuestDeleg(Question q, Container f) {
		super();
		question = q;
		frame = f;
		init("Question <" + question.getNom() + ">");
	}

	public String libelle() {
		if (question.formateFaitsAttendus().isEmpty()) {
			return "Message texte";			
		} else {
			return "Question texte";			
		}
	}
	
	public void remplitZones() {
		getZoneTexte().append(question.getTexte());
	}

	public void construitBoutons() {
		List<List<Object>> listeChoix;
		listeChoix = ToolNos.analyseRegle(question.getRegles());
		String nomBouton = null, nomFait = null;
		if (listeChoix.isEmpty()) {
			fabriqueBouton("Vu", "");
		} else {
				for (List<Object> l : listeChoix) {
				nomBouton = ((List<String>) l.get(0)).get(0);
				nomFait = (String) l.get(1);
				fabriqueBouton(nomBouton, nomFait);
			}
		}
	}

	public void fabriqueBouton(String nomBouton, String nomFait) {
		JButton bouton = new JButton(nomBouton);
		bouton.setToolTipText(nomFait);
		bouton.setName(nomBouton); // pour FEST
		getPanelBoutons().add(bouton);
		bouton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				dispose();
				if (getMoteur() != null) {
					getMoteur().retourne(
							((JButton) evt.getSource()).getToolTipText());
				}
			}
		});
	}

	@Override
	void escape() {
		fermeFenetre();
	}
}
