/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2015-2019 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
 */

package nos.run.edit;

import java.awt.Container;

import nos.obj.Edi;
import nos.obj.Question;

public class FenDialogueQuestHTMLDeleg extends FenDialogueHTMLDeleg
		implements IFenDialogue {
	
	// Obsolete, plus utilisé pour EdiNoS mais conservé pour tests automatisés 
	// pour lesquels intégration de JavaFX pose problème...

	private Question question;

	public FenDialogueQuestHTMLDeleg(Question q, Container f) {
		super();
		question = q;
		frame = f;
		init("Question <" + question.getNom() + ">");
	}

	public String libelle() {
		if (question.formateFaitsAttendus().isEmpty()) {
			return "Message non FX";
		} else {
			return "Question non FX";
		}
	}

	public void remplitZones() {
		editorPane.setText(prepareText());
	}

	private String prepareText() {
		String texte = question.getTexte();
		
		if (getMoteur() != null) {
			texte = getMoteur().valoriseFaits(texte);
		}

		texte = transformeEnBoutons(texte);

		String avant = "<html dir=\"ltr\"><head></head><body contenteditable=\"true\">";
		String debutForm = "<form action=\".\" method=\"post\">";
		String apres = "</body></html>";
		String finForm = "<br><br>";

		if (question.formateFaitsAttendus().isEmpty()) {
			// Message
			finForm = finForm + "<input type=\"submit\" value=\"Vu\"></form>";
		}
		int i = texte.indexOf(avant);
		if (texte.startsWith(avant)) {
			texte = avant + debutForm + texte.substring(i + avant.length());
		} else {
			Edi.nos().montreAvertissement(
					"Erreur de formatage de la question <" + question.getNom()
							+ "> (début)");
		}
		if (texte.endsWith(apres)) {
			texte = texte.substring(0, texte.indexOf(apres)) + finForm + apres;
		} else {
			Edi.nos().montreAvertissement(
					"Erreur de formatage de la question <" + question.getNom()
							+ "> (fin)");
		}
		return texte;
	}

	private String transformeEnBoutons(String texte) {
		texte = texte.replaceAll("type=\"radio\"", "type=\"submit\"");

		String a = "<input";
		String value = "";
		String t = texte;
		while (t.indexOf(a) > 0) {
			value = detecteFait(t);
			texte = texte.replaceAll("value=\""+value+"\"", "value=\"&#8658\" class=\"choix\"" );
			
			t = t.substring(t.indexOf("</p>") + 1);
		}
		return texte;
	}

	public String detecteFait(String texte) {
		String a = "value=\"";
		String b = "\"";
		int i, j;
		i = texte.indexOf(a);
		texte = texte.substring(i + a.length());
		j = texte.indexOf(b);
		return texte.substring(0, j);
	}

	public void construitBoutons() {
	}

	@Override
	void escape() {
		fermeFenetre();
	}
}
