/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2013-2019 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
 */

package nos.run.edit;

import nos.obj.Edi;
import nos.obj.EdiNoS;
import nos.obj.Question;
import nos.run.Moteur;
import nos.utils.PrefsManager;

@SuppressWarnings("serial")
public class FenDialogueQuestJFrame extends FenDialogueJFrame {

	public FenDialogueQuestJFrame(Question q, Moteur m) {
		super(m);
		setDelegue(q);
	}

	public FenDialogueQuestJFrame(Question q) {
		super();
		setDelegue(q);
	}

	private void setDelegue(Question q) {
		// doit être identique à FenDialogueQuest.setDelegue()...

		String prefBoutonRadio = ((PrefsManager) Edi.nos().getPreferences())
				.getQuestionsBoutonRadio();
		String s = q.getTexte().trim();

		if (s.startsWith("<html")) {
			if (((EdiNoS) Edi.nos()).utiliseJavaFX()) {
				if (prefBoutonRadio.equals("sans")) {
					delegue = new FenDialogueQuestHTMLDelegFX(q, this);
				} else if (prefBoutonRadio.equals("avec")) {
					delegue = new FenDialogueQuestHTMLRadioDelegFX(q, this);
				}
			} else {
				// Java 6 ou 7 : Java FX absent...
			}
		} else {
			delegue = new FenDialogueQuestDeleg(q, this);
		}
	}
}
