/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2013 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
*/

package nos.run.edit;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JInternalFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

import nos.edit.FenEdiNoS;
import nos.obj.Edi;
import nos.revinos.Revi;

public class FenDialogueRevinosDeleg extends FenDialogueDeleg implements IFenDialogue{
	private String texte, titre, faitRetourne;

	public FenDialogueRevinosDeleg(String te, String ti, String f, Container fen) {
		super();
		texte = te;
		titre = ti;
		faitRetourne = f;
		frame = fen;
		init(ti);
	}

	public void init(String titre) {
		if (frame instanceof JInternalFrame) {
			((JInternalFrame) frame).setTitle(titre);
			((JInternalFrame) frame).getContentPane().setLayout(
					new BorderLayout());
		} else {
			((JFrame) frame).setTitle(titre);
			((JFrame) frame).getContentPane().setLayout(new BorderLayout());
		}

		JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.LINE_AXIS));
		getBoutonFermer().setText("Fermer");
		panel.add(getBoutonFermer());
		panel.add(Box.createHorizontalGlue());
		panel.setBorder(BorderFactory.createLineBorder(Color.white));
		addToContentPane(panel, BorderLayout.NORTH);

		JPanel panelCentre = new JPanel();
		JPanel panel2 = new JPanel();
		getZoneTexte().setLineWrap(true);
		getZoneTexte().setMargin(new Insets(0, 3, 0, 3));
		panel2.add(getZoneTexte());
		panel2.setMaximumSize(new Dimension(280, 200));

		JPanel panel3 = new JPanel();
		java.net.URL imgURL = FenEdiNoS.class.getResource("/images/Clever le peintre Small.gif");
		ImageIcon image = null;
		if (imgURL != null) {
			image = new ImageIcon(imgURL);
		} else {
			Edi.nos().montreAvertissement("Image non trouvée");
		};
		JLabel label3 = new JLabel(image);
		panel3.add(label3);
		panel3.setMaximumSize(new Dimension(280, 200));
		
		panelCentre.add(panel3, BorderLayout.EAST);
		panelCentre.add(panel2, BorderLayout.WEST);
		addToContentPane(panelCentre, BorderLayout.CENTER);

		setPanelBoutons(new JPanel());
		construitBoutons();
		addToContentPane(getPanelBoutons(), BorderLayout.SOUTH);

		// Register the Listeners
		registerEventListeners();

		remplitZones();

		installeMenus();

		// Resize the container to the preferred size
		if (frame instanceof JInternalFrame) {
			((JInternalFrame) frame).pack();
		} else {
			((JFrame) frame).pack();
		}
	}
	
	public String libelle() {
		return "";
	}

	@Override
	public void construitBoutons() {
		JButton bouton = new JButton("Continuer");
		bouton.setName("Continuer");
		getPanelBoutons().add(bouton);
		bouton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				((FenEdiNoS) Edi.nos().fen()).fermeFen("Actions : "+Edi.nos().getBaseCourante().getNom());
				dispose();
				Revi.nos().ajouteHistorique(titre+"\n");
				getMoteur().retourne(faitRetourne);
			}
		});
	}

	public void remplitZones() {
		getZoneTexte().append(texte);
	}

	@Override
	void escape() {
	}
}
