/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2013-2017 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
 */

package nos.run.edit;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Image;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JInternalFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JPanel;

import nos.obj.Edi;
import nos.obj.NoS;

public class FenFinLancementDeleg extends FenDialogueDeleg implements
		IFenDialogue {

	private String texte;

	private NoS premierNos;
	
	private JButton boutonPlus = new JButton("Plus");

	public FenFinLancementDeleg(Container fen) {
		frame = fen;
		init("Lancement du graphe terminé");
		getZoneTexte().setEditable(false);
	}

	public void init(String titre) {
		if (frame instanceof JInternalFrame) {
			((JInternalFrame) frame).setTitle(titre);
			((JInternalFrame) frame).getContentPane().setLayout(
					new BorderLayout());
		} else {
			((JFrame) frame).setTitle(titre);
			((JFrame) frame).getContentPane().setLayout(new BorderLayout());
		}

		JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.LINE_AXIS));
		getBoutonRetour().setName("Retour"); // pour FEST
		panel.add(getBoutonRetour());
		getBoutonAide().setName("?"); // pour FEST
		getBoutonAide().setToolTipText("Voir la situation");
		panel.add(getBoutonAide());
		getBoutonFermer().setText("Fermer");
		getBoutonFermer().setToolTipText("Fermer la fenêtre");
		getBoutonFermer().setName("Fermer"); // pour FEST
		panel.add(getBoutonFermer());

		panel.add(Box.createHorizontalGlue());
		panel.setBorder(BorderFactory.createLineBorder(Color.white));
		addToContentPane(panel, BorderLayout.NORTH);

		JPanel panel2 = new JPanel();
		panel2.setLayout(new BorderLayout());
		JPanel panel2b = new JPanel();
		JLabel l2 = new JLabel(libelle(), JLabel.CENTER);
		l2.setForeground(Color.BLUE);
		l2.setName("libelle"); // pour FEST
		l2.setAlignmentY(JFrame.CENTER_ALIGNMENT);
		
		panel2b.add(l2, BorderLayout.CENTER);
		panel2b.add(Box.createHorizontalGlue());
		panel2b.setBorder(BorderFactory.createLineBorder(Color.white));
		panel2.add(panel2b, BorderLayout.NORTH);

		java.net.URL imgURL = getClass().getResource("/images/Clever-patient.gif");
		ImageIcon image = null;
		if (imgURL != null) {
			image = new ImageIcon(new ImageIcon(imgURL).getImage().getScaledInstance(250, 250, Image.SCALE_DEFAULT));
		} else {
			Edi.nos().montreAvertissement("Image non trouvée");
		}
		
		JLabel l2t = new JLabel(image);

		panel2.add(l2t, BorderLayout.CENTER);

		panel2.setPreferredSize(new Dimension(350, 270));
		
		addToContentPane(panel2, BorderLayout.CENTER);

		// Register the Listeners
		registerEventListeners();

		if (getMoteur().getLog() != null) {
			premierNos = getMoteur().getNoS().getBase()
					.getGrapheQuiContientNos(getMoteur().getNoS().getNom()).getPremierNoS();
			JPanel panel3 = new JPanel();
			panel3.setLayout(new BoxLayout(panel3, BoxLayout.Y_AXIS));
			getZoneTexte().setBorder(BorderFactory.createLineBorder(Color.black));
			getZoneTexte().setLineWrap(true);
			getZoneTexte().setMargin(new Insets(0, 3, 0, 3));
			getZoneTexte().setName("texte"); // pour FEST
			panel3.add(getZoneTexte());
			panel3.setPreferredSize(new Dimension(350, 200));
			addToContentPane(panel3, BorderLayout.SOUTH);
			
			remplitZones();
			if (getZoneTexte().getLineCount() > 11) {
				panel3.setPreferredSize(new Dimension(350, getZoneTexte()
						.getLineCount() * 18));
			}
		}

		installeMenus();

		// Resize the container to the preferred size
		if (frame instanceof JInternalFrame) {
			((JInternalFrame) frame).pack();
		} else {
			((JFrame) frame).pack();
		}
	}

	public String libelle() {
		return "Nom de la situation finale : " + getMoteur().getNoS().getNom();
	}

	public void remplitZones() {

		texte = "Log du graphe <" + premierNos.getNom() + "> :";
		texte = texte + "\n";
		texte = texte + "-----------------------------\n";
		texte = texte + getMoteur().getLog();
		getZoneTexte().append(texte);
	}

	void registerEventListeners2() {
		boutonPlus.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				voirSituation();
			}
		});
	}

	public void construitBoutons() {
		
	}
	
	public JMenu menuDialogue() {
		JMenu menu = new JMenu("Dialogue");

		menu.add(menuItemVoirSituation());
		menu.add(menuItemEnregistreTrace());
		if (getMoteur().getLog() != null) {
		menu.add(menuItemEnregistreLog());
		}
		menu.addSeparator();
		menu.add(menuItemFermeFenetre());
		return (menu);
	}

	private JMenuItem menuItemEnregistreLog() {
		JMenuItem menuItem = new JMenuItem("Enregistrer log sous...");
		menuItem.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				enregistreLog();
			}
		});
		return menuItem;
	}

	private void enregistreLog() {
		JFileChooser filechoose = new JFileChooser();
		// Créer un JFileChooser
		// filechoose.setCurrentDirectory(new File("."));
		// Le répertoire source du JFileChooser est le répertoire d’où est
		// lancé notre programme
		filechoose.setSelectedFile(new File(premierNos.getNom() + ".log"));
		// Le bouton pour valider l’enregistrement portera la mention
		// Enregistrer
		int resultatEnregistrer = filechoose.showSaveDialog(filechoose);
		if (resultatEnregistrer == JFileChooser.APPROVE_OPTION)
		// Si l’utilisateur clique sur le bouton Enregistrer
		{
			String monFichier = new String(filechoose.getSelectedFile()
					.toString());
			// Récupérer le nom du fichier qu’il a spécifié
			if (monFichier.endsWith(".log")) {
				;
			}
			// Si ce nom de fichier finit par .cou, ne rien faire et
			// passer à la suite
			else {
				monFichier = monFichier + ".log";
			}
			
			// Sinon renommer le fichier pour qu’il porte l’extension .cou
			{
				try {
					FileWriter lu = new FileWriter(monFichier);
					// Créer un objet java.io.FileWriter avec comme argument
					// le mon du fichier dans lequel enregsitrer
					BufferedWriter out = new BufferedWriter(lu);
					// Mettre le flux en tampon (en cache)
					out.write(texte); //
					// Balancer dans le flux le contenu de la zone de texte
					out.close(); // Fermer le flux (c’est
					// toujours mieux de le fermer explicitement)
				} catch (IOException er) {
					er.printStackTrace();
				}
			}
		}
	}

	@Override
	void escape() {
		fermeFenetre();
	}
}
