/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2013 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
*/

package nos.run.edit;

import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;

import javax.swing.JButton;

import nos.obj.Edi;
import nos.obj.Procedure;
import nos.run.SimuleProc;
import nos.utils.PrefsManager;

public class FenSimuleProcDeleg extends FenDialogueDeleg implements IFenDialogue {

	private Procedure proc;

	private SimuleProc sp;

	private List<String> faits;

	public FenSimuleProcDeleg(Procedure p, SimuleProc simuleProc, List<String> f,
			Container fen) {
		super();
		proc = p;
		sp = simuleProc;
		faits = f;
		frame = fen;
		init("Simulation de procédure");
		getZoneTexte().setEditable(false);
	}

	public void construitBoutons() {
		String nomBouton = null, s = null;
		int i = 1;

		if (faits == null) {
			fabriqueBouton("(vide)", "");
		} else {
			for (String nomFait : faits) {
				s = getZoneTexte().getText();
				String prefs = ((PrefsManager) Edi.nos().getPreferences())
						.getSimuleProcBoutons();
				if (prefs.equals("numéros")) {
					nomBouton = "" + i;
					getZoneTexte().setText(
							s + "Choix " + i + " = " + nomFait + "\n");
					i++;
				} else if (prefs.equals("faits")) {
					if (nomFait.equals("")) {
						nomBouton = "(vide)";
					} else {
						nomBouton = nomFait;
					}
				}
				
				fabriqueBouton(nomBouton, nomFait);
			}
		}
	}

	private void fabriqueBouton(String nomBouton, String nomFait) {
		JButton bouton = new JButton(nomBouton);
		bouton.setToolTipText(nomFait);
		bouton.setName(nomBouton); // pour FEST
		getPanelBoutons().add(bouton);
		bouton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				dispose();
				sp.retourne(((JButton) evt.getSource()).getToolTipText());
			}
		});
	}

	public String libelle() {
		return ("Quel fait renvoie <" + proc.getNom() + "> ?");
	}

	@Override
	public void remplitZones() {
	}

	@Override
	void escape() {
		fermeFenetre();
	}
}
