/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2013 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
*/

package nos.run.edit;

import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;

import nos.obj.Procedure;
import nos.run.SimuleProc;

public class FenSimuleProcPropTypeeDeleg extends FenDialogueDeleg implements IFenDialogue {

	private Procedure proc;

	private SimuleProc sp;

	private String prop;

	private String type;

	public FenSimuleProcPropTypeeDeleg(Procedure p, SimuleProc simuleProc,
			String nomProp, String typeProp, Container fen) {
		super();
		proc = p;
		sp = simuleProc;
		prop = nomProp;
		type = typeProp;
		frame = fen;
		init("Simulation de procédure");
	}

	public void construitBoutons() {
		fabriqueBouton("OK", prop);
	}

	private void fabriqueBouton(String nomBouton, String nomFait) {
		JButton bouton = new JButton(nomBouton);
		bouton.setToolTipText(nomFait);
		bouton.setName(nomBouton); // pour FEST
		getPanelBoutons().add(bouton);
		bouton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				dispose();
				sp.retourne(prop+" "+getZoneTexte().getText());
			}
		});
	}

	public String libelle() {
		return ("<html><center>Quel fait renvoie &lt;" + proc.getNom() + "&gt; ?"
				+ "<br/><br/>" +"<font color=\"black\">"+
				"Entrez la valeur de la propriété<br/>&lt;" + prop +" "+type+"&gt; :</font></center></html>");
	}

	public void remplitZones() {
	}

	@Override
	void escape() {
		fermeFenetre();
	}
}
