/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2013 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
*/

package nos.utils;

import java.io.IOException;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;

public class ParserInt extends ParserNod {

	// constructeur
	public ParserInt(String nomFichier) throws SAXException, IOException {
		super(nomFichier);
	}

	public void startDocument() throws SAXException {
		emit("<?xml version='1.0' encoding='iso-8859-1' standalone='no'?>");
		nl();
		emit("<!DOCTYPE interface SYSTEM '../edinos.int.dtd'>");
	}

	public void startElement(String arg0, String arg1, String arg2,
			Attributes arg3) throws SAXException {
		noeud = arg1;
		nl();
		emit("<" + arg1);
		if ((noeud != "procedure")  && (noeud != "ecran") && (noeud != "basEcran")) {
			emit(">");
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.xml.sax.ContentHandler#characters(char[], int, int)
	 */
	public void characters(char[] arg0, int arg1, int arg2) throws SAXException {
		String tab[];
		String chaine = new String(arg0, arg1, arg2);
		if (chaine.trim().equals("")) {
			return;
		}
		
		if (noeud == "procedure") {
			tab = chaine.split(" ");
			emit(" nom=\"" + tab[0] + "\">");
		} else if (noeud == "ecran"){
			tab = chaine.split(" ");
			emit(" nom=\"" + tab[0] + "\">");
		} else if (noeud == "basEcran"){
			tab = chaine.split(" ");
			emit(" nom=\"" + tab[0] + "\">");
		} else if ((noeud == "texte")||(noeud == "zone")){
			nl();
			emit(chaine);
		} else if (noeud != "interface"){
			nl();
			emit(chaine.trim());
		}
	}
}
