/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2013 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
*/

package nos.utils;

import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.Writer;

import org.xml.sax.Attributes;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.XMLReaderFactory;

public class ParserNod extends DefaultHandler {

	protected String noeud;

	static protected Writer out;

	static protected String res;

	// constructeur
	public ParserNod(String nomFichier) throws SAXException, IOException {
		XMLReader saxReader = null;
		String nomSysteme = System.getProperty("os.name").split(" ")[0];
		if (nomSysteme.equals("Mac")) {
			saxReader = XMLReaderFactory
					.createXMLReader("com.sun.org.apache.xerces.internal.parsers.SAXParser");
		}
		;
		if (nomSysteme.equals("Windows")) {
			saxReader = XMLReaderFactory.createXMLReader();
		}
		;

		out = new OutputStreamWriter(System.out);
		res = "";

		saxReader.setContentHandler(this);
		saxReader.parse("file:" + nomFichier);
	}

	public void setDocumentLocator(Locator arg0) {
	}

	public void startDocument() throws SAXException {
		emit("<?xml version='1.0' encoding='iso-8859-1' standalone='no'?>");
		nl();
		emit("<!DOCTYPE graphe SYSTEM '../edinos.nod.dtd'>");
	}

	public void endDocument() throws SAXException {
	}

	public void startPrefixMapping(String arg0, String arg1)
			throws SAXException {
	}

	public void endPrefixMapping(String arg0) throws SAXException {
	}

	public void startElement(String arg0, String arg1, String arg2,
			Attributes arg3) throws SAXException {
		noeud = arg1;
		nl();
		emit("<" + arg1);
		if ((noeud != "nos") && (noeud != "graphe") && (noeud != "suivantsVue")) {
			emit(">");
		}
	}

	public void endElement(String arg0, String arg1, String arg2)
			throws SAXException {
		nl();
		emit("</" + arg1 + ">");
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.xml.sax.ContentHandler#characters(char[], int, int)
	 */
	public void characters(char[] arg0, int arg1, int arg2) throws SAXException {
		String tab[];
		String chaine = new String(arg0, arg1, arg2);
		if (chaine.trim().equals("")) {
			return;
		}
		;
		if (noeud == "nos") {
			tab = chaine.split(" ");
			emit(" nom=\"" + tab[0] + '"');
			emit(" position=\"" + tab[1] + tab[2] + tab[3] + "\">");
		} else if (noeud == "graphe") {
			emit(" nom=\"" + chaine + "\">");
		} else if (noeud == "suivantsVue") {
			tab = chaine.split(" ");
			emit(" origine=\"" + tab[0] + "\">");
			for (int i = 1; i < tab.length; i++) {
				nl();
				emit(" <dest>" + tab[i] + "</dest>");
			}
		} else {
			nl();
			emit(chaine.trim());
		}
	}

	public void ignorableWhitespace(char[] arg0, int arg1, int arg2)
			throws SAXException {
	}

	public void processingInstruction(String arg0, String arg1)
			throws SAXException {
	}

	public void skippedEntity(String arg0) throws SAXException {
	}

	// Wrap I/O exceptions in SAX exceptions, to
	// suit handler signature requirements
	protected void emit(String s) throws SAXException {
		try {
			out.write(s);
			out.flush();
			res = res + s;

		} catch (IOException e) {
			throw new SAXException("I/O error", e);
		}
	}

	protected void nl() throws SAXException {
		String lineEnd = System.getProperty("line.separator");
		try {
			out.write(lineEnd);
			res = res + lineEnd;
		} catch (IOException e) {
			throw new SAXException("I/O error", e);
		}
	}

	public String resultat() {
		return res;
	}
}
