/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2019 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
*/

package nos.run;

import java.io.Serializable;
import java.util.List;

public class ArchiveMemoire implements Serializable {

	private static final long serialVersionUID = 1L;

	private List<MemoireArchivee> listeMemoiresArchivees;

	public List<MemoireArchivee> getMemoiresArchivees() {
		return listeMemoiresArchivees;
	}

	public void setMemoiresArchivees(List<MemoireArchivee> l) {
		this.listeMemoiresArchivees = l;
	}

	public void ajoute(MemoireArchivee t) {
		listeMemoiresArchivees.add(t);
	}

	public void montreDerniereArchive() {
		if (listeMemoiresArchivees.size() > 0) {
			MemoireArchivee m = listeMemoiresArchivees.get(listeMemoiresArchivees.size()-1);
			System.out.println("Dernière archive = "+m.getMemoire().ligneHistorique());
		}
	}
	
	public void montreTaillesArchives() {
		for (MemoireArchivee f : listeMemoiresArchivees) {
			Histo h = f.getMemoire().getHistoriqueFaits();
			System.out.println("Taille = "+h.getFaitsconnus().size());
		}
	}

	public void retireDerniereArchive() {
		if (listeMemoiresArchivees.size() > 0) {
			listeMemoiresArchivees.remove(listeMemoiresArchivees.size()-1);
		}
	}

	public MemoireArchivee getMemoireArchivee(String nomAction) {
		for (MemoireArchivee f : listeMemoiresArchivees) {
			if (f.getAction().equals(nomAction)) {
				return f;
			}
		}
		return null;
	}
}
