/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2020 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
 */

package nos.run;

import java.util.ArrayList;
import java.util.List;

import javax.swing.ImageIcon;
import javax.swing.table.AbstractTableModel;

@SuppressWarnings("serial")
public class ErreursVerif extends AbstractTableModel {

	protected String[] colonnes = new String[] { "", "NoS", "Erreur", "" };

	protected List<Object[]> listeErreurs;

	public ErreursVerif() {
		super();
		listeErreurs = new ArrayList<Object[]>();
	}

	public void supprime(int row) {
		listeErreurs.remove(row);
		this.fireTableDataChanged();
	}

	public void ajouteData(String string, String string2) {
		java.net.URL imgURLDel = getClass().getResource("/icones/cross.png");
		java.net.URL imgURLDet = getClass().getResource("/icones/page_edit.png");
		Object[] tab = { new ImageIcon(imgURLDel), string, string2, new ImageIcon(imgURLDet) };
		listeErreurs.add(tab);
	}

	public int getColumnCount() {
		return colonnes.length;
	}

	public int getRowCount() {
		return listeErreurs.size();
	}

	public Object getValueAt(int i, int j) {
		Object[] ligne = listeErreurs.get(i);
		return ligne[j];
	}

	public boolean isCellEditable(int row, int col) {
		switch (col) {
		case 0: // colonne Bouton Supprimer
			return true;
		case 1: // colonne NoS
			return false;
		case 2: // colonne Erreur
			return true;
		case 3: // colonne Bouton Voir
			return true;
		default:
			return false;
		}
	}

	public void setValueAt(Object value, int row, int col) {
		Object[] ligne = listeErreurs.get(row);
		ligne[col] = value;
		fireTableCellUpdated(row, col);
	}

	public String getColumnName(int c) {
		return (colonnes[c]);
	}
}
