/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2019 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
*/

package nos.run;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

public class Histo implements Serializable {
	// objet pour JSON
	
	private static final long serialVersionUID = 1L;
	
//    @JsonUnwrapped
	private List<FaitRenvoye> faitsconnus;

	public List<FaitRenvoye> getFaitsconnus() {
		return faitsconnus;
	}

	public void setFaitsconnus(List<FaitRenvoye> faitsconnus) {
		this.faitsconnus = faitsconnus;
	}

	public void affiche() {
		for (FaitRenvoye t : faitsconnus) {
			System.out.println("Fait connu : "+t.getFait()+" <- "+t.getAction());
		}
	}

	public void ajoute(FaitRenvoye t) {
		faitsconnus.add(t);		
	}

	public void retire(String nomAction) {
		List<FaitRenvoye> faitsAretirer = new ArrayList<FaitRenvoye>();

		for (FaitRenvoye f : faitsconnus) {
			if (f.getAction().equals(nomAction)) {
				faitsAretirer.add(f);
			}
		}
		faitsconnus.removeAll(faitsAretirer);
	}
}

