/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2013-2019 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
*/

package nos.run;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import nos.obj.Edi;
import nos.obj.NoS;
import nos.obj.Procedure;
import nos.obj.Question;
import nos.utils.ToolNos;

public class MoteurAction extends Moteur {
	// anciennement CycleAction
	
	private static final long serialVersionUID = 1L;

	// "*** Sert à calculer les faits attendus d'un nos :       	***"
	// "*** utilisé par NoS>>tousLesProcsEtFaitsAttendus pour   	***"
	// "*** VueBase>>popUpMenu et par NoS>>tousLesFaitsAttendus.	***"
	//
	// "*** <structureFaits> sert à stocker ces faits attendus.    	***"
	// "*** Son format est le suivant : collection d'associations  	***"
	// "*** nomProc => collection de faits (nomProc apparaît       	***"
	// "*** autant de fois qu'il compte de lignes-déclaration      	***"

	private Map<String, List<String>> structureFaits;

	public MoteurAction(NoS n) {
		super(n, null, null);
		structureFaits = new HashMap<String, List<String>>();
	}

	protected void suiteDeclenche() {
		// ne rien faire...
	}

	protected void afficher(String s) {
		continueActions();
	}
	
	protected void afficherTexte(String s) {
		continueActions();
	}
	
	protected void ajouter(String chaine) {
		List<List<String>> col = ToolNos.asStructureFait(chaine);
		
		if (chaine != null) {
			structureFaits.put("[]", col.get(0));
		}
		continueActions();
	}
	
	protected void declencher(String s) {
		continueActions();
	}

	protected void evaluer(String chaine) {
		Procedure p = null;
		p = Edi.nos().getProc(chaine);

		if (p != null) {
			List<String> l2 = new ArrayList<String>();
			for (List<String> l : p.formateFaitsAttendus()) {
				l2.addAll(l);
			}
			structureFaits.put(p.getNom(), l2);
		}
		
		continueActions();
	}
	
	protected void evaluer(String chaine, String param) {
		evaluer(chaine);
	}

	protected void demander(String chaine) {
		Question q = null;
		q = Edi.nos().getQuestion(chaine);

		if (q != null) {
			List<String> l2 = new ArrayList<String>();
			for (List<String> l : q.formateFaitsAttendus()) {
				l2.addAll(l);
			}
			structureFaits.put(q.getNom(), l2);
		}

		continueActions();
	}

	public void executeActions() {
		super.executeActions();
	}

	public Map<String, List<String>> descriptionFaitsAttendus() {
		// public List<Map.Entry<String, String>> descriptionFaitsAttendus() { // LPO
		return structureFaits;
	}
}
