/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2013 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
*/

package nos.utils;

import java.io.File;
import java.io.IOException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import nos.obj.Edi;

import org.w3c.dom.Document;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.xml.sax.helpers.DefaultHandler;

public class ConstruitDom extends DefaultHandler {

	private org.w3c.dom.Document document;
	private String nomFichier;

	public ConstruitDom(String s) {
		nomFichier = s;
	}

	private void chargeXML() throws SAXException, IOException {

		
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		factory.setValidating(true);
		try {
			DocumentBuilder builder = factory.newDocumentBuilder();
			builder.setErrorHandler(this);
			builder.setEntityResolver(new MonResolver());
			
			document = builder.parse(new File(nomFichier));

		} catch (SAXException sxe) {
			// Error generated during parsing)
			throw sxe;

		} catch (ParserConfigurationException pce) {
			// Parser with specified options can't be built
			pce.printStackTrace();

		} catch (IOException ioe) {
			// I/O error
			throw ioe;
		}
		
	}

	public boolean testeEtChargeXML() {
		try {
			chargeXML();

		} catch (Exception t) {
			t.printStackTrace();
			Edi.nos().montreInfo(t.getMessage());
			return (false);
		}
		;
		return (true);
	}
		
	// ===========================================================
	// ErrorHandler methods
	// ===========================================================

	// treat validation errors as fatal
	public void error(SAXParseException e) throws SAXParseException { 
		throw e;
	}

	// dump warnings too
	public void warning(SAXParseException err) throws SAXParseException {
		/*
		 * System.out.println("** Warning" + ", line " + err.getLineNumber() + ",
		 * uri " + err.getSystemId()); System.out.println(" " +
		 * err.getMessage());
		 */
		throw err;
	}

	public Document document() {
		return document;
	}

}
