/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2013-2018 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
*/

package nos.utils;

import org.xml.sax.EntityResolver;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

public class MonResolver implements EntityResolver {
    public InputSource resolveEntity(String publicID, String systemID)
        throws SAXException {
    	System.out.println("systemID="+systemID);

		 if (systemID.endsWith("edinos.int.dtd"))  {
			 	return new InputSource(this.getClass().getResourceAsStream("/schemas/edinos.int.dtd"));	
		 }
		 if (systemID.endsWith("edinos-interface-2.0.dtd"))  {
			 	return new InputSource(this.getClass().getResourceAsStream("/schemas/edinos-interface-2.0.dtd"));	
		 }
		 if (systemID.endsWith("edinos.nod.dtd"))  {
			 	return new InputSource(this.getClass().getResourceAsStream("/schemas/edinos.nod.dtd"));	
		 }
        // If no match, returning null makes process continue normally
        return null;
    }
}
