/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2013 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
*/

package nos.utils;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;

import org.jdom.DocType;
import org.jdom.output.Format;
import org.jdom.output.XMLOutputter;
import org.xml.sax.helpers.DefaultHandler;

public class SauveDom extends DefaultHandler {

	private String nomFichier;
	
	private org.jdom.Document jdoc;

	public SauveDom(org.jdom.Document doc) {
		jdoc = doc;
		nomFichier = doc.getBaseURI();

		try {
			ToolNos.JDOMtoDOM(doc);
		} catch (Exception e) {
			// TODO Auto-generated catch block : throws ...
			e.printStackTrace();
		}
	}

	public void sauveJ(String dtd, String doctype) throws FileNotFoundException, IOException {
		
		DocType dt = new DocType(doctype, dtd);
		jdoc.setDocType(dt);
		Format f = Format.getPrettyFormat();
		f.setTextMode(Format.TextMode.PRESERVE);  // Pas de trim sur les champs texte
		f.setEncoding("iso-8859-1");
		XMLOutputter sortie = new XMLOutputter(f);
		sortie.output(jdoc, new FileOutputStream(nomFichier));
	}
}
