/*
  EdiNoS - Editeur de NoS
  Copyright (C) 2013 - 2019 - Luc Poittevin — Tous droits réservés.
  Contact : edinos@free.fr  -  https://www.edinos.org
  
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la “GNU General Public License” telle que
  publiée par la Free Software Foundation : soit la version 3 de cette
  licence, soit (à votre gré) toute version ultérieure.
  
  Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
  AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
  ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
  Publique GNU pour plus de détails.
  
  Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
  ce programme ; si ce n’est pas le cas, consultez :
  <http://www.gnu.org/licenses/>. 
*/

package nos.run;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Enumeration;
import java.util.Properties;

public class Interface {

//	public static void donneDuLait(Moteur m) {
//		System.out.println("Interface : donneDuLait");
//		m.retourne("donneDuLait");
//	}
	
	public static void departement(Moteur m) {
		System.out.println("Interface / departement : 26");
		m.retourne("26");
	}
	
	public static void proprietesSystem(Moteur m) {
		Properties props = System.getProperties();
		Enumeration<?> propertyNames = props.propertyNames();
		String cle = "";
		while (propertyNames.hasMoreElements()) {
			cle = (String) propertyNames.nextElement();
			System.out.println("clé = "+cle+" - valeur = "+props.getProperty(cle));
		}
		m.retourne("");
	}

	public static void jour(Moteur m) {
		m.retourne((new SimpleDateFormat("E dd/MM/yyyy")).format(new Date()));
	}
	
	public static void heure(Moteur m) {
		m.retourne((new SimpleDateFormat("HH:mm:ss")).format(new Date()));
	}

	public static void nomUtilisateur(Moteur m) {
		m.retourne(System.getProperties().getProperty("user.name"));
	}
	
	public static void langueUtilisateur(Moteur m) {
		m.retourne(System.getProperties().getProperty("user.language"));
	}
	
	public static void systemeExploitation(Moteur m) {
		m.retourne(System.getProperties().getProperty("os.name"));
	}
}
